unit AscMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Comm, Buttons, ExtCtrls, ComCtrls, Menus,IniFiles, system.UITypes;//, ExMemo;

type
  TAscNadiaForm = class(TForm)
    FontDialog1: TFontDialog;
    Panel1: TPanel;
    ConnectBtn: TSpeedButton;
    FontBtn: TSpeedButton;
    StatusBar1: TStatusBar;
    DisconnectBtn: TSpeedButton;
    Edit1: TEdit;
    SetBtn: TBitBtn;
    PopupMenu1: TPopupMenu;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Memo1: TMemo;
    clearbtn: TBitBtn;
    Label1: TLabel;
    BreakSend: TBitBtn;
    Panel2: TPanel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    Comm1: TComm;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShowHint(Sender: TObject);
    procedure ChangeFormSize;
    procedure ConnectBtnClick(Sender: TObject);
    procedure FontBtnClick(Sender: TObject);
    procedure DisconnectBtnClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure SetBtnClick(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure clearbtnClick(Sender: TObject);
    procedure SpeedButtonClick(Sender: TObject);  //Xs[h{^荞
    procedure BreakSendClick(Sender: TObject);
    procedure Comm1CommEvent(Sender: TObject; EventMask: TCommEventMask);
    procedure Comm1CommReceive(Sender: TObject; Size: Cardinal);
    procedure Comm1CommErrEvent(Sender: TObject; ErrCode: Cardinal);

  private
    FPs: Integer;                           // ǂݏo|C^[
    FPe: Integer;                           // ݃|C^[
    RecvBuf: array [0..131] of ansiChar;         // Mobt@[   128 + #13#10 + #3 + #0

    procedure AddToMemo(Flag: Boolean);
    procedure IniFileRead;  // CjVt@C̓ǂݏo
    procedure IniFileWrite; // CjVt@C̏
    procedure TextSend(indat: string);
    procedure textWrite;
    procedure textRead;
  public
    Fpmax:    integer;
    procedure VerText;
    { Public 錾 }
  end;

var
  AscNadiaForm: TAscNadiaForm;
  F1: TextFile;{t@C}
  inifname: string;
  LLn:   string;
  fsize:  integer;
  Fstyle1: Tfontstyles;
  Fstyle2: Tfontstyles;
  Fstyle3: Tfontstyles;
  Fstyle4: Tfontstyles;
  fsbyte:  byte;
  openf:   bool = False;      // comopef
  delimiterF :Byte;           // 0 LFCR 1 CR 2 LF 3 STXETX
  BaudSpeed:    integer;
  dbyte,pbyte,sbyte,fbyte: byte;
  oWord:   Word;
  BufS: string;
  stxF: Boolean;
  STX:  ansiChar = #02;
  ETX:  ansiChar = #03;
  ETX1: ansiChar = #00;
  TimeOutD: DWORD = 1000;     // M^CAEgmsec
  BreakSendTime: DWORD = 500; // u[NM
  EventCharInD:  ansichar = #10;  // 荞ݎMtO
  EventF: byte;               // rbgO@ʏ튄荞݁@//rbgP w
  EventChars:  Word = 1;      // 荞ݔ

const
  CRLF = #13#10;
  CR = #13;
  LF = #10;

implementation

uses AsccomSet;
{$R *.DFM}

var
  InSize : Word;              // M\p
  delimitCoad: ansiChar;      // ̋؂R[h
  DiNullCoad: ansiChar;       // \R[h
  count: integer;             // sJE^


{ tH[̍쐬 }
procedure TAscNadiaForm.textWrite;
var
  II : integer;
  Cpm: TComponent;
begin
  inifname := ChangeFileExt(Application.ExeName,'.txt');
  try
    AssignFile(F1,inifname);
    ReWrite(F1);
  except
    exit;
  end;
  for II := 2 to 11 do
    begin
      Cpm := FindComponent('Edit' + IntToStr(II));
      BufS := TEdit(Cpm).Text;
      Writeln(F1,BufS);
    end;
  CloseFile(F1);
end;

procedure TAscNadiaForm.textRead;
var
  II : integer;
  Cpm: TComponent;
begin
  inifname := ChangeFileExt(Application.ExeName,'.txt');
  if not FileExists(inifname) then Exit;
  AssignFile(F1,inifname);
  Reset(F1);
  for II := 2 to 11 do
    begin
      Cpm := FindComponent('Edit' + IntToStr(II));
      Readln(F1,BufS);
      TEdit(Cpm).Text := BufS;
    end;
  closeFile(F1);
end;

procedure TAscNadiaForm.IniFileWrite; // CjVt@C̏
var
  MyIniFile: TIniFile;
  CharOut:Byte;
begin
  inifname := ChangeFileExt(Application.ExeName,'.ini');
  MyIniFile := TIniFile.Create(inifname);
  CharOut := byte(EventCharInD);
  try
    with MyIniFile do
      begin
        WriteInteger('Baud Rate','Rate',BaudSpeed);       // {[[g
        WriteInteger('Data Bits','Bits',dbyte);           // rbg
        WriteInteger('Parity Check','Parity',pbyte);      // peB
        WriteInteger('Stop Bits','Bits',sbyte);           // Xgbvrbg
        WriteInteger('flow Control','Control',fbyte);     // t@NV
        WriteInteger('PoatNo','No',oWord);                // portNo
        WriteInteger('Text Length','Length',FPmax);       // ő啶
        WriteInteger('Font Size','size',fsize);           // TCY
        WriteInteger('Font Style','Style',fsbyte);;       // R[h
        WriteInteger('delimiter','coad',delimiterF);
        WriteInteger('delimiter','STX',Byte(STX));
        WriteInteger('delimiter','ETX',Byte(ETX));
        WriteInteger('delimiter','ETX1',Byte(ETX1));
        WriteInteger('TimeOutData','TimeOut',TimeOutD);   // ^CAEgݒ
        WriteInteger('BreakSendTime','BreakTime',BreakSendTime);  // u[NM
        WriteInteger('Event','EventCharInD',CharOut);
        WriteInteger('Event','EventF',EventF);
      end;
  except
    application.MessageBox('CjVt@C߂܂','',0);
  end;
  MyIniFile.Free;
end;

procedure TAscNadiaForm.IniFileRead; // CjVt@C̓ǂݏo
var
  MyIniFile: TIniFile;
  CharIn:Byte;
begin
  inifname := ChangeFileExt(Application.ExeName,'.ini');
  MyIniFile := TIniFile.Create(inifname);
  try
    with MyIniFile do
      begin
        BaudSpeed := ReadInteger('Baud Rate','Rate',9600);      // {[[g
        dbyte := ReadInteger('Data Bits','Bits',8);             // rbg
        pbyte := ReadInteger('Parity Check','Parity',0);        // peB
        sbyte := ReadInteger('Stop Bits','Bits',0);             // Xgbvrbg
        fbyte := ReadInteger('flow Control','Control',0);       // t@NV
        oWord := ReadInteger('PoatNo','No',1);                  // portNo
        FPmax := ReadInteger('Text Length','Length',80);        // ő啶
        fsize := ReadInteger('Font Size','size',8);             // TCY
        fsbyte := ReadInteger('Font Style','Style',0);;         // R[h
        delimiterF := ReadInteger('delimiter','coad',0);        // ̋؂
        STX := ansichar(ReadInteger('delimiter','STX',2));
        ETX := ansiChar(ReadInteger('delimiter','ETX',3));
        ETX1 := ansiChar(ReadInteger('delimiter','ETX1',0));
        TimeOutD := ReadInteger('TimeOutData','TimeOut',1000);          // TCY
        BreakSendTime := ReadInteger('BreakSendTime','BreakTime',500);  // u[NM
        CharIn := Readinteger('Event','EventCharInD',0);
        EventF := ReadInteger('Event','EventF',1);
      end;
  Finally
    MyIniFile.Free;
  end;
  EventCharInD := ansiChar(CharIn);
  If (FPmax < 40) or (FPmax > 128) then FPmax := 80;
end;

procedure TAscNadiaForm.VerText;
var
  FLstr: string;
begin
  BaudSpeed := Comm1.BaudRate;
  dbyte := byte(Comm1.ByteSize);
  pbyte := byte(Comm1.ParityBits);
  sbyte := byte(Comm1.StopBits);
  fbyte := byte(Comm1.FlowControls);
  oWord := Word(Comm1.port);
  BufS := 'Ver 4.3  ' + 'BaudRate ' + intToStr(BaudSpeed) + '  ByteSize ' + IntTostr(dbyte + 4);
  BufS := BufS + '  Parity ';
  case pbyte of
      0: FLstr := 'None';
      1: FLstr := 'odd';
      2: FLstr := 'even';
      3: FLstr := 'Mark';
      4: FLstr := 'space';
    end;
  BufS := BufS + FLstr;
  case sbyte of
      0: FLstr := '1';
      1: FLstr := '1.5';
      2: FLstr := '2';
  end;

  BufS := BufS + '  StopBits ' + FLstr + '  PortNo ' + IntTostr(oWord) + '  FlowControls ';
  FLstr := 'None';
  if Fbyte and 4 = 4 Then FLstr := 'XonXoff';
  if Fbyte and 2 = 2 then FLstr := FLstr + 'RtsCts';
  if Fbyte and 1 = 1 then FLstr := FLstr + 'DtrDsr';
  BufS := BufS + FLstr;
  BufS := BufS + '  delimiter ';
  case delimiterF of
    0:  BufS := BufS + 'None';
    1:  BufS := BufS + 'As@$0D$0A';
    2:  BufS := BufS + 'A    @   $0D';
    3:  BufS := BufS + '    s@   $0A';
    4:  begin
          if ETX1 = #0 then
             BufS := BufS + 'Stx Etx  $'+ IntToHex(Byte(STX),2) + '$' + IntToHex(Byte(ETX),2)
            else
             BufS := BufS + 'Stx Etx  $'+ IntToHex(Byte(STX),2) + '$' + IntToHex(Byte(ETX),2)
                                                                + '$' + IntToHex(Byte(ETX1),2);
        end;
  end;
  AscNadiaForm.Caption := BufS;
  BufS := '';
end;

procedure TAscNadiaForm.FormCreate(Sender: TObject);
var
  Cpm: TComponent;
  II: integer;
begin
  BorderStyle := bsSingle;
  Fstyle1 := [];
  Fstyle2 := [fsBold];
  Fstyle3 := [fsItalic];
  Fstyle4 := [fsBold,fsItalic];
  for II := 2 to 11 do
    begin
      Cpm := FindComponent('Edit' + intTostr(II));
      Tedit(Cpm).Text := '';
      Tedit(Cpm).Visible := False;
      Tedit(Cpm).Hint := 'Mf[^[' + '|' + 'M{^őM';
    end;
  for II := 1 to 10 do
    begin
      Cpm := FindComponent('SpeedButton' + intTostr(II));
      TSpeedButton(Cpm).Caption := 'M';
      TSpeedButton(Cpm).Visible := False;
      TSpeedButton(Cpm).Hint := 'M' + '|' + 'NbNőM'+ #13#10 + '̏Ȃ';
      TSpeedButton(Cpm).OnClick := SpeedButtonClick;
      TSpeedButton(Cpm).Tag := II;
    end;
  with Canvas do begin Font.name := 'lr SVbN';Font.style := [fsBold];Font.Size := 10;
                       Font.Pitch := fpFixed; end;
  Panel1.Height := 22;
  with ConnectBtn do begin  Font.height := 13;height := 22;width := 40;left := 0;Top := 0;end;
  with DisConnectBtn do begin Font.height := 13;height := 22;width := 40;left := 40;Top := 0;end;
  with SetBtn do begin Font.height := 13;height := 22;width := 40;left := 40;Top := 0;end;
  with FontBtn do begin Font.height := 13;height := 22;width := 40;left := 80;Top := 0;end;
  with clearbtn do begin Font.height := 13;height := 22;width := 40;left := 120;Top := 0;end;
  with BreakSend do begin Font.height := 9;height := 22;width := 40;left := 160;Top := 0;
                          caption := 'Break' + #13#10 + 'Send'; Visible := False; end;
  with Edit1 do begin Font.height := 13;height := 22;width := 40;left := 200;Top := 0;
                      Visible := False;height := 25;end;
  with StatusBar1 do begin Font.height := 15;height := 22;end;
  with memo1 do begin Font.Name := 'lr SVbN';Font.Pitch := fpFixed;Font.style := [];
                                                                  Font.Size := 8;end;
  with Label1 do begin Font.Height := 10; Top := 5; Visible := False;end;

  Application.HintPause := 600;             // wvqg̕\ҋ@
  Application.OnHint := ShowHint;           // qg\pCxgnh
  Fpmax := 80;                              // 80ɃZbg
                                            // tH[TCY̕ύX
  FPs := 0;                                 // sobt@̊Jn|C^
  FPe := 0;                                 // sobt@̏݃|C^
  BaudSpeed := 2400;                        // CjVt@CꍇQSOO{[ɐݒ
  dbyte := 4;                               // CjVt@CꍇWrbgɐݒ
  pbyte := 0;                               // CjVt@CꍇpeBɐݒ
  sbyte := 0;                               // CjVt@CꍇXgbvrbgPɐݒ
  fbyte := 0;                               // CjVt@CꍇXonXoff  DtrDsroff RtsCtsoff ɐݒ
  oWord := 1;                               // CjVt@Cꍇport 1 ɐݒ
  LLn := 'lr SVbN';
  fsize := 8;
  fsbyte := 0;
  IniFileRead;                              // CjVt@C̓ǂݏo
{ CjVt@C̓eɂCOM|[g@Mݒ }
  case fsbyte of
    0: Canvas.Font.Style := Fstyle1;
    1: Canvas.Font.Style := Fstyle2;
    2: Canvas.Font.Style := Fstyle3;
    3: Canvas.Font.Style := Fstyle4;
  end;
  Comm1.BaudRated := User_BaudRate;
  Comm1.BaudRate := BaudSpeed;
  case dbyte of
    4 : Comm1.ByteSize := cbs8;
    3 : Comm1.ByteSize := cbs7;
    2 : Comm1.ByteSize := cbs6;
    1 : Comm1.ByteSize := cbs5;
    0 : Comm1.ByteSize := cbs4;
  end;
  case pbyte of
    0: Comm1.ParityBits := cpbNone;
    1: Comm1.ParityBits := cpbodd;
    2: Comm1.ParityBits := cpbeven;
    3: Comm1.ParityBits := cpbMark;
    4: Comm1.ParityBits := cpbspace;
  end;
  case sbyte of
    0 : Comm1.StopBits :=csb1;
    1 : Comm1.StopBits :=csb15;
    2 : Comm1.StopBits :=csb2;
  end;
  case fbyte of
    0 : Comm1.FlowControls := [];
    1 : Comm1.FlowControls := [cfcDtrDsr];
    2 : Comm1.FlowControls := [cfcRtsCts];
    3 : Comm1.FlowControls := [cfcRtsCts,cfcDtrDsr];
    4 : Comm1.FlowControls := [cfcXonXoff];
    5 : Comm1.FlowControls := [cfcXonXoff,cfcDtrDsr];
    6 : Comm1.FlowControls := [cfcRtsCts,cfcXonXoff];
    7 : Comm1.FlowControls := [cfcRtsCts,cfcXonXoff,cfcDtrDsr];
  end;
  if (oWord > 256) or (oWord < 1) then oWord := 1;
  Comm1.port := oWord;
  Comm1.ReaderrShow := ShowOff;
  Comm1.SendTimeOut := TimeOutD;
  Comm1.ReceiveTimeOut := TimeOutD;
  Comm1.ReceiveInterval := MAXDWORD;
  Comm1.ReceiveMultiplier := 0;
  Comm1.SendMultiplier := 0;
  if eventF = 1 then
    begin
      if Comm1.ReaderrShow = ShowOff then Comm1.EventMask := [evRxchar,evBreak]
                                     else Comm1.EventMask := [evRxchar,evBreak,evErr];
      Comm1.EventFlag := Null;
      Comm1.EventFlagIn := #0;
      Comm1.RxflagReceive := eventOff;
    end;
  if eventF = 2 then
    begin
      if Comm1.ReaderrShow = ShowOff then Comm1.EventMask := [evRxflag,evBreak]
                                     else Comm1.EventMask := [evRxflag,evBreak,evErr];
      Comm1.EventFlag := UserIn;
      Comm1.EventFlagIn := EventCharInD;
      Comm1.RxflagReceive := eventOn;
    end;
  Canvas.Font.Pitch := fpFixed;             // \悤ɌŒsb`ɂ
  Canvas.Font.name := LLn;
  Canvas.Font.size := fsize;
  ChangeFormSize;                           // tHgTCYɂtH[̃TCYύX
  Memo1.Lines.clear;                        // Memo1 NA
  textRead;                                 // Mf[^[ǂݍ
  VerText;                                  // vOo[W\
end;


{ tH[̃N[Y }
procedure TAscNadiaForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  textWrite;                                // Mpf[^[ݕۑ
  if openf then Comm1.Close;
  BaudSpeed := Comm1.BaudRate;
  dbyte := byte(Comm1.ByteSize);
  pbyte := byte(Comm1.ParityBits);
  sbyte := byte(Comm1.StopBits);
  fbyte := byte(Comm1.FlowControls);
  oWord := Word(Comm1.port);
  LLn := Memo1.Font.name;
  fsize := Memo1.Font.size;
  fsbyte := 0;
  if Fstyle1 = Canvas.Font.Style then fsbyte := 0;
  if Fstyle2 = Canvas.Font.Style then fsbyte := 1;
  if Fstyle3 = Canvas.Font.Style then fsbyte := 2;
  if Fstyle4 = Canvas.Font.Style then fsbyte := 3;
  IniFileWrite;                             // CjVt@C̏
end;


{ R|[lgɃ}EXJ[\ꍇ }
{ Xe[^Xo[Ƀqg\ }
procedure TAscNadiaForm.ShowHint(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := Application.Hint;
end;


{ tHg̕ύX w肷ꍇtHg͌Œsb`ɂ@FontDialog̃IvVɌŒsb`Ă }
procedure TAscNadiaForm.FontBtnClick(Sender: TObject);
begin
  FontDialog1.Font := Canvas.Font;              // tHg_CAOtHg
  if FontDialog1.Execute then                   // tHg_CAO\
  begin                                         // OKꂽ
    Canvas.Font := FontDialog1.Font;            // tH[̃tHgύX
    ChangeFormSize;                             // tH[TCYύX
  end;
end;


{ tHgύXɂʃTCY̕ύX }
procedure TAscNadiaForm.ChangeFormSize;
var
  Cx,wi: Integer;
  Lleng : string;
  cpm : Tcomponent;
begin
  memo1.Font := Canvas.Font;
  Lleng := '';
  for wi := 0 to Fpmax + 2 do Lleng := Lleng + 'A';
  Cx := Canvas.TextWidth(Lleng);                // Fpmax + 2̕̕
  wi :=                                         // tH[̘g
       Cx +                                     // Fpmax + 2̕
       GetSystemMetrics(SM_CXVSCROLL) +         // cXN[o[̕
       GetSystemMetrics(SM_CXFRAME) * 2;        // t[
  if wi > Screen.width then
          Fpmax := (Screen.width - GetSystemMetrics(SM_CXVSCROLL)
                                   - GetSystemMetrics(SM_CXFRAME) * 2) div Canvas.TextWidth('A') - 1;
  AscNadiaForm.ClientWidth :=                   // tH[̘g
       Cx +                                     // Fpmax + 2̕
       GetSystemMetrics(SM_CXVSCROLL) +         // cXN[o[̕
       GetSystemMetrics(SM_CXFRAME) * 2 +       // t[
       300;                                     // E]
  AscNadiaForm.ClientHeight := (abs(memo1.Font.Height) + 2) * 27;
  memo1.ClientWidth := Cx;
  memo1.height := Clientheight - Panel1.Height - StatusBar1.Height;
  memo1.left := 0;
  memo1.top := Panel1.Height;
  Edit1.Left := BreakSend.Left + BreakSend.Width;
  Edit1.width := Clientwidth - Edit1.Left - 100;
  Label1.Left := Edit1.Left + Edit1.width + 3;
  Edit2.Height := abs(memo1.Font.Height) + 10;
  SpeedButton1.Height := Edit2.height;
  Panel2.Top:= Panel1.Height;
  Panel2.Height := Clientheight - Panel1.Height - StatusBar1.Height;
  Panel2.Left := memo1.Width;
  Panel2.Width := ClientWidth - Memo1.Width;
  for wi := 1 to 10 do
    begin
      cpm := FindComponent('SpeedButton' + intTostr(wi));
      TSpeedButton(Cpm).Left := Panel2.ClientWidth - Setbtn.Width;
      TSpeedButton(Cpm).Top := Panel2.height div 10 * (wi - 1);
      TSpeedButton(Cpm).Height := SpeedButton1.Height;
      TSpeedButton(Cpm).Font.Height := Setbtn.Font.Height;
      TSpeedButton(Cpm).Width := Setbtn.Width;
    end;
  for wi := 2 to 11 do
    begin
      cpm := FindComponent('Edit' + intTostr(wi));
      TEdit(Cpm).Font.Height := memo1.Font.Height;
      TEdit(Cpm).Left := 0;
      TEdit(Cpm).Top := memo1.height div 10 * (wi - 2);
      TEdit(Cpm).Width := Panel2.ClientWidth - SpeedButton1.Width;
      TEdit(Cpm).Height := Edit2.height;
    end;
end;

// ------------ ʐM֘A֐Q ----------------------------------------------

{ M @AnsiR[hŏ}
procedure TAscNadiaForm.Comm1CommReceive(Sender: TObject; Size: Cardinal);
const
  LeadByte: ansiChar = #0;                              // Pڕۑp  ftHg #0
  NullStr: string = '';                                 // Null 
var
  Buf: PansiChar;                                       // Mobt@p
  i: Integer;
  AnsiGstr: ansistring;
begin
  Buf := AllocMem(Size + 1);                            // M[̊m
  Comm1.Read(Buf, Size);                                // RS232C̓ǂݍ
  for i := 0 to Size - 1 do                             // M
    begin
      if Leadbyte <> #0 then                            // Q
        begin
          if Fpe = Fpmax - 1 then AddToMemo(True);      // PsɓȂ͓񕶎Kv
          RecvBuf[FPe] := LeadByte;                     // ͂܂Ƃ߂ăobt@ɃZbg銿P
          RecvBuf[FPe+1] := Buf[i];                     // Q
          Inc(FPe,2);                                   // obt@Gh񕶎CNg
          if FPe = Fpmax then AddToMemo(True);          // PstɂȂ
          LeadByte := #0;                               // PڗpNA
        end
        else
          if IsDBCSLeadByte(Byte(Buf[i]))               // Pڂ犿Pڂ͗߂邾
            then LeadByte := Buf[i]                     // ꕶڂLeadByteɕۑ
              else
                if Buf[i] = delimitCoad then            // ؂蕶  ؂蕶 $0D  $OA   w肳ꂽR[h
                  begin
                    if delimiterF = 4 then              // f~^[ ETXgp
                      begin
                        if not (ETX in [#0,#10,#13]) then   // ETX  #0,#10,#13 ܂܂ĂȂ
                          begin
                            RecvBuf[FPe] := ETX;            // ETXR[hǉ R[hɂĂMemo1ɕ\Ȃ
                            inc(FPe);                       // PCNg
                          end;
                        if not (ETX1 in [#0,#10,#13]) then  // ETX1  #0,#10,#13 ܂܂ĂȂ
                          begin
                            RecvBuf[FPe] := ETX1;           // ETX1R[hǉ R[hɂĂMemo1ɕ\Ȃ
                            inc(FPe);                       // PCNg
                          end;
                      end;
                    AddToMemo(True)                         // Fpmaxȉłswŕ\ǉ
                  end
                  else
                    if Buf[i] = #8 then                     // BS()
                      begin
                        if FPe = FPs then                   // Memoɏo͍ς
                          begin
                            if FPs > 0 then                 // słȂꍇ
                              begin                         // POIANullŒu
                                memo1.SelStart := memo1.SelStart - 1;  // wʒuP߂
                                memo1.SelLength := 1;                  // PI
                                AnsiGstr := ansistring(memo1.seltext); // 當擾Ansicoadϊ
                                if IsDBCSLeadByte(Byte(AnsiGstr[1])) then   // R[h
                                  begin
                                    Dec(FPs);                   // ubt@JEgX^[gPobN
                                    Dec(Fpe);                   // ubt@JEgGhPobN
                                  end;
                                SendMessage(memo1.Handle, EM_REPLACESEL, 0,Integer(PChar(NullStr)));  // I𕶎kŒu
                                if FPs > 0 then
                                  begin
                                    Dec(FPs);                   // ubt@JEgX^[gPobN
                                    Dec(Fpe);                   // ubt@JEgGhPobN
                                  end;
                              end;
                          end
                          else
                          begin
                            if (Fpe - Fps) > 1 then
                              if IsDBCSLeadByte(Byte(RecvBuf[Fpe - 2])) then Dec(Fpe);   // P߂
                            Dec(Fpe);                     // ܂Memoɏo͂ĂȂGhPobN
                          end;
                        RecvBuf[Fpe] := #0;               // Ō̕k
                      end
                      else
                        if not (Buf[i] in [#0, DiNullCoad]) then  // NULLDiNullCoad͖
                          begin                           // Nif̏ꍇANull͍s̓
                            RecvBuf[FPe] := Buf[i];       // obt@ɕZ
                            Inc(FPe);                     // ubt@GhJE^[CNg
                            if FPe = Fpmax then AddToMemo(True);  // w蕶ɒBswŏo
                          end;
    end;
  if FPe > FPs then AddToMemo(False);                     // obt@ɗ܂Ăó@swȂ
  FreeMem(Buf,Size+1);                                    // M[̊J
  InSize := Size;                                         // MTCY\plZbg
end;

{ ւ̒ǉ }
procedure TAscNadiaForm.AddToMemo(Flag: Boolean);
var
  AddStr: string;                           // Memoo͗p UNICoad
  dmpstr: ansistring;                       // ansicoad -> unicoad p
  II: integer;
begin
  Label1.Caption := 'ŏI=' + intTostr(InSize);
  if Flag then                              // sw@True@Ȃ畜Asǉ
    begin
      RecvBuf[FPe]   := CR;                 // Aǉ
      RecvBuf[FPe+1] := LF;                 // sǉ
      Inc(Fpe, 2);                          // 񕶎CNg
    end;
  RecvBuf[FPe] := #0;
  dmpstr := '';
  for II := Fps to Fpe do dmpstr := dmpstr + RecvBuf[II];  // M̎o Fps -> Fpe
  AddStr := string(dmpstr);                 // ansiCode -> unicode
  if Flag then                              // SɂPso͎wtO True Ȃso͂
  begin
    FPs := 0;                               // u@bt@X^[gJE^[NA
    FPe := 0;                               // u@bt@GhJE^[NA
    inc(count);                             // sJE^[CNg
    if count > 25 then                      // QTsz
      begin
        count := 0;                         // sJE^[NA
        Memo1.Clear;                        // Memo1 NA
        AddStr := string(RecvBuf);          // Memo1 NAꂽ̂ŁAPsSďo͂ ansiCode -> unicode
      end;
  end
  else                                      // Mo M̎o Fps -> Fpe͎sς
    FPs := FPe;                             // Mo͂̂ŁAubt@X^[gJE^[̒lGh̒lɂ
  memo1.selStart := memo1.GetTextLen;       // o͐memo1̍ŌɃZbg
  SendMessage(memo1.Handle, EM_REPLACESEL, 0, Integer(Pchar(AddStr)));  // memo1ɏo͂
end;

{ ڑ }
procedure TAscNadiaForm.ConnectBtnClick(Sender: TObject);
var
  II : integer;
  Cpm : TComponent;
begin
  try
    Comm1.Open;
  except
    MessageDlg('|[gOPENo܂B', mtInformation,[mbOk], 0);
    DisconnectBtn.Down := True;
    exit;
  end;
  openf := true;                              // VAʐMI[vtO
  stxF := False;
  memo1.SetFocus;                             // TMemoɃtH[JX
  memo1.TabStop := false;
  Edit1.Visible := true;
  Edit1.Text := '';
  BreakSend.Visible := True;
  Label1.Visible := True;
  Label1.Caption := 'ŏI=0';
  setBtn.Visible := False;
{ sR[h̐ݒ }
  delimitCoad := CR;                                  // ؂蕶̐ݒ
  DiNullCoad  := LF;                                  // R[hݒ
  if (delimiterF = 0) or (delimiterF = 2) then
    begin
      delimitCoad := CR;                               // $0D ŉs
      DiNullCoad  := LF;                               // $0A ͖
    end;
  if (delimiterF = 1) or (delimiterF = 3) then
    begin
      delimitCoad := LF;                               // $0A ŉs
      DiNullCoad  := CR;                               // $0D ͖
    end;
  if delimiterF = 4 then
    begin
      if ETX1 = #0 then
        begin
          delimitCoad := ETX;                          // ETX ŉs
          DiNullCoad  := #0;                           // ̂̓k
        end                                            // k͖
        else
        Begin
          delimitCoad := ETX1;                         // ETX1 ŉs
          DiNullCoad  := ETX;                          // ETX͖
        end;
    end;
{ MpEdit yс@Xs[h{^\ }
  for II := 2 to 11 do
    begin
      Cpm := FindComponent('Edit' + IntToStr(II));
      TEdit(Cpm).Visible := true;
    end;
  for II := 1 to 10 do
    begin
      Cpm := FindComponent('SpeedButton' + intTostr(II));
      TSpeedButton(Cpm).Visible := True;
    end;
end;


{ ؒf }
procedure TAscNadiaForm.DisconnectBtnClick(Sender: TObject);
var
  II : integer;
  Cpm : TComponent;
begin
  Comm1.Close;
  openf := False;
  edit1.Visible := false;
  setBtn.Visible := True;
  Label1.Visible := False;
  BreakSend.Visible := False;
  for II := 2 to 11 do
    begin
      Cpm := FindComponent('Edit' + IntToStr(II));
      TEdit(Cpm).Visible := False;
    end;
  for II := 1 to 10 do
    begin
      Cpm := FindComponent('SpeedButton' + intTostr(II));
      TSpeedButton(Cpm).Visible := False;
    end;
end;

{ M̌ɉsR[ht M̈וR[h@UNICoad -> ansicoad ϊ }
procedure TAscNadiaForm.TextSend(indat: string);  // MsR[hǉ
var
  SendStr: ansiString;
  indath : ansiString;
begin
  indath := ansistring(indat);
  Case delimiterF of
    0: SendStr := indath;
    1: SendStr := indath + CRLF;
    2: SendStr := indath + CR;
    3: SendStr := indath + LF;
    4: begin
        if ETX1 = #0 then
            SendStr := STX + indath + ETX
          else
            SendStr := STX + indath + ETX + ETX1;
       end;
  end;
  Comm1.SendString(SendStr);
end;

{ Edit1̃L[͕ Enteer őM }
procedure TAscNadiaForm.Edit1KeyPress(Sender: TObject; var Key: Char);
var
  leng:  integer;
  inst:  string;
begin
  if key = CR then
    begin
      inst := Edit1.Text;
      leng := length(inst);
      if leng <> 0 then TextSend(inst);
      key := #0;
      Edit1.Text := '';
    end;
end;

{ tH[TCYύX }
procedure TAscNadiaForm.FormResize(Sender: TObject);
begin
  ChangeFormSize;
end;

{ ݒ{^NbN }
procedure TAscNadiaForm.SetBtnClick(Sender: TObject);
begin
  AscComsetForm.Show;
  AscNadiaForm.Hide;
  AscComsetForm.setcomm1disp;
  AscComsetForm.top := AscNadiaForm.top;
  AscComsetForm.left := AscNadiaForm.left;
end;

{ Memo1 Cpoy past cut  }
procedure TAscNadiaForm.Copy1Click(Sender: TObject);
begin
  memo1.copyToclipboard;
end;

procedure TAscNadiaForm.Cut1Click(Sender: TObject);
begin
  memo1.CutToClipboard;
end;

procedure TAscNadiaForm.Paste1Click(Sender: TObject);
begin
  memo1.PasteFromClipboard;
end;

{ Memo1NA{^ }
procedure TAscNadiaForm.clearbtnClick(Sender: TObject);
begin
  Memo1.Visible := True;
  Memo1.Lines.clear;
  if Edit1.Visible then
    begin
      Edit1.SetFocus;
      Edit1.Text := '';
    end;
end;

{ MpSpeedButtonNbN }
procedure TAscNadiaForm.SpeedButtonClick(Sender: TObject);
var
  leng: integer;
  Tags: integer;
  inst: string;
  CPM : TComponent;
begin
  Tags := TSpeedButton(Sender).Tag;
  CPM := FindComponent('Edit' + IntToStr(Tags + 1));
  inst := TEdit(CPM).Text;
  leng := length(inst);
  if leng <> 0 then TextSend(inst);
end;

{ u[NM }
procedure TAscNadiaForm.BreakSendClick(Sender: TObject);
begin
  Comm1.SendBreak;
end;

{ u[NM }
procedure TAscNadiaForm.Comm1CommEvent(Sender: TObject;EventMask: TCommEventMask);
var
  Z, X: integer;
  S: ansistring;
begin
  if evBreak in EventMask then              // evBreakL
    begin
      S := 'Break';                         // BreakZbg
      Z := Length(S);                       // Break̒
      for X := 1 to Z do
        begin
          RecvBuf[FPe] := S[X];             // ubt@ɃRs[
          Inc(FPe);
          if FPe > Fpmax then AddToMemo(true);
        end;
      if Fpe > Fps then AddToMemo(false);
    end;
end;

procedure TAscNadiaForm.Comm1CommErrEvent(Sender: TObject;
  ErrCode: Cardinal);
begin
  application.MessageBox('G[','err',0);
end;

end.
