unit Hexcomset;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Spin, Registry;

type
    Baud= array [1..17] of DWord;
    THexcomsetForm = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    SpinButton1: TSpinButton;
    Edit1: TEdit;
    BitBtn11: TBitBtn;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    BitBtn12: TBitBtn;
    BitBtn13: TBitBtn;
    BitBtn14: TBitBtn;
    ComboBox1: TComboBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure BitBtn11Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure BitBtn10Click(Sender: TObject);
    procedure BitBtn12Click(Sender: TObject);
    procedure BitBtn13Click(Sender: TObject);
    procedure BitBtn14Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);

  private
    { Private 錾 }
    procedure commsetclear;
    procedure btnalloff;
    procedure PortNoin;
    procedure BaudRatein;
    procedure ByteSizein;
    procedure StopBitsin;
    procedure ParityBitsin;
    procedure XonXoffin;
    procedure RtsCtsin;
    procedure DtrDsrin;
    procedure setupin;
    procedure coadNoin;
    procedure BreakTimein;
    procedure TimeOutin;
  public
    { Public 錾 }
    procedure setcomm1disp;
  end;


var
  HexcomsetForm: THexcomsetForm;

const
  Ratein:Baud =(110,300,600,1200,2400,4800,9600,19200,38400,57600,
                115200,128000,230400,256000,460800,512000,921600);

implementation

uses HexMain,UsbComm;

var
   iicomset : integer;
   inpflg:     byte;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr 8,portNo
                    // 9. s 10.u[NM
   infflg:     byte;//۰p
   xpos,ypos,xxpos:        integer;
   LL: string;

{$R *.DFM}

procedure THexcomsetForm.commsetclear;
var
  CRect:  TRect;
begin
  CRect := Rect(0,0,Panel1.Clientwidth,Panel1.ClientHeight);
  Image1.canvas.Brush.style := bsSolid;
  Image1.canvas.Brush.color := clwhite;
  Image1.canvas.FillRect(CRect);
end;

procedure THexcomsetForm.btnalloff;
var
  Cpm: TComponent;
  II: integer;
begin
  for II := 1 to 14 do
    begin
      Cpm := FindComponent('BitBtn' + IntToStr(II));
      TBitBtn(Cpm).Visible := False;
    end;
  for II := 1 to 5 do
    begin
      Cpm := FindComponent('RadioButton' + IntToStr(II));
      TRadioButton(Cpm).Visible := False;
      TRadioButton(Cpm).Checked := False;
    end;
  Edit1.Visible := False;
  Spinbutton1.Visible := False;
  combobox1.Visible := false;
end;

procedure THexcomsetForm.TimeOutin;
begin
  commsetclear;
  btnalloff;
  with Edit1 do begin
    Visible := True;
    left := 150;
    Top := 200;
    width := 70;
    height := 25;
    Font.height := 20;
    text := intToStr(HexNadiaForm.UsbComm1.SendTimeOut);
  end;
  with Spinbutton1 do begin
    Visible := True;
    Top := 200;
    Left := Edit1.left + Edit1.width;
    height := 25;
    Width := 25;
  end;
  with BitBtn11 do begin
    Visible := True;
    Top := 300;
    width := 80;
    Left := HexcomsetForm.ClientWidth div 2 - Width div 2;
    height := 25;
  end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'M^CAEgԁ@r');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50, 30,'M^CAEgԂ~bPʂŎw肵܂B');
    TextOut(50, 45,'W͂POOOrłB');
    TextOut(50, 60,'ʐMxxAMf[^[ꍇ́A^CAEgԂ𒷂܂B');
    TextOut(50, 75,'^CAEg𒴂Ȃ͈͂̒ŋ؂đMΘAőMo܂B');
    TextOut(50, 90,'M̓^CAEgԂɊ֌WȂMł܂B');
    Font.height := 17;
    Font.color := clRed;
    TextOut(50,105,'Ow肷ƃ^CAEg͎gp܂B');
  end;
end;

procedure THexcomsetForm.BreakTimein;
begin
  commsetclear;
  btnalloff;
  with Edit1 do begin
    Visible := True;
    left := 150;
    Top := 100;
    width := 50;
    height := 25;
    Font.height := 20;
    text := intToStr(HexNadiaForm.UsbComm1.BreakSendTime);
  end;
  with Spinbutton1 do begin
    Visible := True;
    Top := 100;
    Left := Edit1.left + Edit1.width;
    height := 25;
    Width := 25;
  end;
  with BitBtn11 do begin
    Visible := True;
    Top := 250;
    width := 80;
    Left := HexcomsetForm.ClientWidth div 2 - Width div 2;
    height := 25;
  end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'u[NMԁ@r');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'u[NMMԂ~bPʂŎw肵܂B');
    TextOut(50,45,'W͂TOOrłB');
    TextOut(50,60,'USB TO RS232C@ł͑M݂̂̕܂B');
  end;
end;

procedure THexcomsetForm.coadNoin;
begin
  commsetclear;
  btnalloff;
  with Edit1 do begin
    Visible := True;
    left := 150;
    Top := 100;
    width := 50;
    height := 25;
    Font.height := 20;
    text := intToStr(hexNo);
  end;
  with Spinbutton1 do begin
    Visible := True;
    Top := 100;
    Left := Edit1.left + Edit1.width;
    height := 25;
    Width := 25;
  end;
  with BitBtn11 do begin
    Visible := True;
    Top := 250;
    width := 80;
    Left := HexcomsetForm.ClientWidth div 2 - Width div 2;
    height := 25;
  end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'Psɕ\gR[h');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'Psɕ\gR[hݒ肷AƉʂ');
    TextOut(50,45,'͂ݏôŒӂĉB');
    TextOut(50,60,'gpĂtHgƃtHg̃TCYɂĂω܂B');
  end;
end;

procedure THexcomsetForm.ComboBox1Change(Sender: TObject);
var
  comstr: string;
  leng:  integer;
begin
  comstr := ComboBox1.Text;
  leng := Length(comstr);
  comstr := copy(comstr, 4, leng - 3);
  HexNadiaForm.UsbComm1.port := strtoint(comstr);
  Edit1.text := intToStr(HexNadiaForm.UsbComm1.port);
end;

procedure THexcomsetForm.PortNoin;
var
  i : integer;
begin
  commsetclear;
  btnalloff;
  with Edit1 do begin
    Visible := True;
    left := 150;
    Top := 120;
    width := 50;
    height := 25;
    Font.height := 20;
    text := intToStr(HexNadiaForm.UsbComm1.Port);
  end;
  with Spinbutton1 do begin
    Visible := True;
    Top := 120;
    Left := Edit1.left + Edit1.width;
    height := 25;
    Width := 25;
  end;
  with BitBtn11 do begin
    Visible := True;
    Top := 250;
    width := 80;
    Left := HexcomsetForm.ClientWidth div 2 - BitBtn11.width div 2;
    height := 25;
  end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'|[gm̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'p\RɂAݒo|[gmقȂ܂B(P`QTU)');
    TextOut(50,45,'ӂĉB');
  end;
  with combobox1 do begin
    Visible := True; Top := 120; Left := 300; Width := 120; Height := 20;
    Font.height := 15;
  end;
  with TRegistry.Create(KEY_READ) do
    try
      RootKey := HKEY_LOCAL_MACHINE;
      OpenKey('HARDWARE\DEVICEMAP\SERIALCOMM', False);
      GetValueNames(ComboBox1.Items);
      for i:=0 to ComboBox1.items.count-1 do
        begin
          ComboBox1.items[i]:=ReadString(ComboBox1.items[i]);
        end;
    finally
      free;
    end;
end;

procedure THexcomsetForm.BaudRatein;
var
  jj : integer;
begin
  for jj := 1 to 17 do
    begin
      iicomset := jj;
      if  HexNadiaForm.UsbComm1.BaudRate = Ratein[jj] then break;
    end;
  commsetclear;
  btnalloff;
  with Edit1 do begin
    Visible := True;
    left := 100;
    Top := 100;
    width := 150;
    height := 25;
    Font.height := 20;
    text := intToStr(Ratein[iicomset]);
  end;
  with Spinbutton1 do begin
    Visible := True;
    Top := 100;
    Left := Edit1.left + Edit1.width;
    Height := 25;
    Width := 25;
  end;
  with BitBtn11 do begin
    Visible := True;
    Top := 250;
    Left := 300;
    width := 80;
    height := 25;
  end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'ʐMx̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'p\RɂAݒoʐMxقȂ܂B');
    TextOut(50,45,'ӂĉB');
  end;
end;

procedure THexcomsetForm.ByteSizein;
var
  iil: byte;
  II : Integer;
  Cpm: TComponent;
begin
  commsetclear;
  btnalloff;
  for II := 1 to 5 do
    begin
      Cpm := FindComponent('RadioButton' + IntToStr(II));
      TRadioButton(Cpm).width := 100;
      TRadioButton(Cpm).height := 25;
      TRadioButton(Cpm).top := 70 + 30 * II;
      TRadioButton(Cpm).left := 150;
      TRadioButton(Cpm).Caption := intTostr(9 - II) + '  bit';
      TRadioButton(Cpm).Visible := True;
    end;
  with BitBtn11 do begin
    Top := 250;
    Left := 300;
    width := 80;
    height := 25;
    Visible := True;
  end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'f[^[̃rbg̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'𑗂ꍇ́AWrbgʂłB');
    TextOut(50,45,'AXL[R[ĥ݂́AWrbǵArbgłB');
  end;
  iil := byte(HexNadiaForm.UsbComm1.ByteSize);
  case iil of
    4: RadioButton1.Checked := True;
    3: RadioButton2.Checked := True;
    2: RadioButton3.Checked := True;
    1: RadioButton4.Checked := True;
    0: RadioButton5.Checked := True;
  end;
end;

procedure THexcomsetForm.StopBitsin;
var
  iil: byte;
begin
  commsetclear;
  btnalloff;
  with RadioButton1 do begin
    width := 100;
    height := 25;
    top := 100;
    left := 150;
    Caption := '1   bit';
    Visible := True;
  end;
  with RadioButton2 do begin
    width := 100;
    height := 25;
    left := 150;
    top := 150;
    Caption := '1.5 bit';
    Visible := True;
  end;
  with RadioButton3 do begin
    width := 100;
    height := 25;
    top := 200;
    left := 150;
    Caption := '2   bit';
    Visible := True;
  end;
  with BitBtn11 do begin
    Top := 250;
    Left := 300;
    width := 80;
    height := 25;
    Visible := True;
  end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'Xgbvrbg̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'ʏ́AXgbvrbg̐́APƂ܂B');
  end;
  iil := byte(HexNadiaForm.UsbComm1.StopBits);
  case iil of
    0: RadioButton1.Checked := True;
    1: RadioButton2.Checked := True;
    2: RadioButton3.Checked := True;
  end;
end;

procedure THexcomsetForm.ParityBitsin;
var
   iil: byte;
begin
  commsetclear;
  btnalloff;
  with RadioButton1 do begin Visible := True;width := 100;height := 25;top := 100;left := 150;
                             Caption := 'None';end;
  with RadioButton2 do begin Visible := True;width := 100;height := 25;top := 130;left := 150;
                             Caption := 'odd';end;
  with RadioButton3 do begin Visible := True;width := 100;height := 25;top := 160;left := 150;
                             Caption := 'even';end;
  with RadioButton4 do begin Visible := True;top := 190;width := 100;height := 25;left := 150;
                             Caption := 'Mark';end;
  with RadioButton5 do begin Visible := True;width := 100;height := 25;top := 220;left := 150;
                             Caption := 'space';end;
  with BitBtn11 do begin Visible := True;Top := 250;Left := 300;width := 80;height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'peBrbg̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'ʐMG[`FbNp̃rbgłB');
    TextOut(50,45,'̏ꍇ́ApeBrbgꍇ܂B');
  end;
  iil := byte(HexNadiaForm.UsbComm1.ParityBits);
  case iil of
    0: RadioButton1.Checked := True;
    1: RadioButton2.Checked := True;
    2: RadioButton3.Checked := True;
    3: RadioButton4.Checked := True;
    4: RadioButton5.Checked := True;
  end;
end;

procedure THexcomsetForm.XonXoffin;
var
   iil: byte;
begin
  commsetclear;
  btnalloff;
  with RadioButton1 do begin Visible := True;width := 100;height := 25;top := 100;left := 150;
                             Caption := 'None';end;
  with RadioButton2 do begin Visible := True;width := 100;height := 25;top := 150;left := 150;
                             Caption := 'XonXoff';end;
  with BitBtn11 do begin Visible := True;Top := 250;Left := 300;width := 80;height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'ʐM̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'M\ǂ̐łB');
    TextOut(50,45,'M\ǂAɁAf[^[𑗂邱ƂŐ䂷@B');
  end;
  iil := byte(HexNadiaForm.UsbComm1.FlowControls);
  iil := iil and 4;
  case iil of
    0: RadioButton1.Checked := True;
    4: RadioButton2.Checked := True;
  end;
end;

procedure THexcomsetForm.RtsCtsin;
var
   iil: byte;
begin
  commsetclear;
  btnalloff;
  with RadioButton1 do begin Visible := True;width := 100;height := 25;top := 100;left := 150;
                             Caption := 'None';end;
  with RadioButton2 do begin Visible := True;width := 100;height := 25;top := 150;left := 150;
                             Caption := 'RtsCts';end;
  with BitBtn11 do begin Visible := True;Top := 250;Left := 300;width := 80;height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'ʐM̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'M\ǂ̐łB');
    TextOut(50,45,'M\ǂAڐڑꂽMōs@łB');
  end;
  iil := byte(HexNadiaForm.UsbComm1.FlowControls);
  iil := iil and 2;
  case iil of
    0: RadioButton1.Checked := True;
    2: RadioButton2.Checked := True;
  end;
end;

procedure THexcomsetForm.DtrDsrin;
var
   iil: byte;
begin
  commsetclear;
  btnalloff;
  with RadioButton1 do begin Visible := True;width := 100;height := 25;top := 100;left := 150;
                             Caption := 'None';end;
  with RadioButton2 do begin Visible := True;width := 100;height := 25;top := 150;left := 150;
                             Caption := 'DtrDsr';end;
  with BitBtn11 do begin Visible := True;Top := 250;Left := 300;width := 80;height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,10,'ʐM̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'M\ǂ̐łB');
    TextOut(50,45,'ʓIɁAfƂ̊ԂŒڐڑꂽMōs܂B');
  end;
  iil := byte(HexNadiaForm.UsbComm1.FlowControls);
  iil := iil and 1;
  case iil of
    0: RadioButton1.Checked := True;
    1: RadioButton2.Checked := True;
  end;
end;

procedure THexcomsetForm.setupin;
begin
  case inpflg of // 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
    1:  BaudRatein;
    2:  ByteSizein;
    3:  StopBitsin;
    4:  ParityBitsin;
    5:  XonXoffin;
    6:  RtsCtsin;
    7:  DtrDsrin;
    8:  PortNoin;
    9:  coadNoin;
    10: BreakTimein;
    11: TimeOutin;
  end;
end;

procedure THexcomsetForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  HexNadiaForm.close;
end;


procedure THexcomsetForm.FormCreate(Sender: TObject);
var
  BRect:  TRect;
  Bitmap: TBitmap;		{rbg}bvێꎞϐ }
  II: integer;
  Cpm: TComponent;
begin
  BorderStyle := bssingle;
  BorderIcons := [biSystemMenu,biMinimize];
  ClientHeight := 425;
  Clientwidth := 570;
  Bitmap := TBitmap.Create;	 {rbg}bvIuWFNg쐬 }
  Bitmap.Width := Clientwidth;		{̕w肷 }
  Bitmap.Height := ClientHeight;		{̍w肷 }
  BRect := Rect(0,0,Clientwidth,ClientHeight);
  with Image1 do begin
    Picture.Graphic := Bitmap;	 {C[WRg[Ƀrbg}bvݒ肷 }
    Top := 0;
    left := 0;
    width := HexcomsetForm.Clientwidth;
    Height := HexcomsetForm.ClientHeight;		{̍w肷 }
    canvas.Brush.style := bsSolid;
    canvas.Brush.color := clwhite;
    canvas.FillRect(BRect);
  end;
  for II := 1 to 14 do
    begin
      Cpm := FindComponent('BitBtn' + IntToStr(II));
      TBitBtn(Cpm).Left := 24;
      if II < 12 then TBitBtn(Cpm).top :=  40 + 26 * (II - 1)
                 else TBitBtn(Cpm).top :=  40 + 26 * (II - 2);
      TBitBtn(Cpm).Height := 21;
      TBitBtn(Cpm).Font.Height := 11;
      if II = 11 then TBitBtn(Cpm).Font.Height := 14;
    end;
  inpflg := 0;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr 8,portNo
end;

procedure THexcomsetForm.setcomm1disp;
var
  iil,iid: integer;
  Cpm: TComponent;
begin
  commsetclear;
  btnalloff;
  for iil := 1 to 14 do
    begin
      Cpm := FindComponent('BitBtn' + IntToStr(iil));
      TBitBtn(Cpm).Visible := True;
    end;
  with Image1.canvas do begin
    Font.name := 'lr SVbN';
    Font.style := [];
    Font.height := 12;
    Font.Color := clblack;
    textOut(30, 10, 'M[h̐ݒ');
    LL := intTostr(HexNadiaForm.UsbComm1.BaudRate);
    xpos := bitbtn1.left + bitbtn1.width + 10;
    xxpos := xpos + 70;
    ypos := bitbtn1.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'bԂ̃f[^[]xirbgjB');
    iil := byte(HexNadiaForm.UsbComm1.ByteSize) + 4;
    LL := intTostr(iil);
    xpos := bitbtn2.left + bitbtn2.width + 10;
    ypos := bitbtn2.top + 2;
    textOut(xxpos, ypos, '̒l̃rbg@S`WrbgAPoCg͂WrbgB');
    textOut(xpos, ypos, LL);
    iil := byte(HexNadiaForm.UsbComm1.StopBits);
    case iil of
      0: LL := '1';
      1: LL := '1.5';
      2: LL := '2';
    end;
    xpos := bitbtn3.left + bitbtn3.width + 10;
    ypos := bitbtn3.top + 2;
    textOut(xxpos, ypos, '̒l̍Ō̃rbgAf[^[̓ǂݍݎ');
    textOut(xxpos, ypos + 12, ']Ԍ덷̕␳ׂ̗̈]Tׂ̈̃rbgB');
    textOut(xpos, ypos, LL);
    //BYTE Parity;           // 0-4=no,odd,even,mark,space
    iil := byte(HexNadiaForm.UsbComm1.ParityBits);
    case iil of
      0: LL := 'None';
      1: LL := 'odd';
      2: LL := 'even';
      3: LL := 'Mark';
      4: LL := 'space';
    end;
    xpos := bitbtn4.left + bitbtn4.width + 10;
    ypos := bitbtn4.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'peBrbgMG[̌opAw肷B');
    textOut(xxpos, ypos + 12, '{́ApeBB');
    iid := byte(HexNadiaForm.UsbComm1.FlowControls);
    iil := iid and 4;
    case iil of
      0: LL := 'None';
      4: LL := 'XonXoff';
    end;
    xpos := bitbtn5.left + bitbtn5.width + 10;
    ypos := bitbtn5.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, '񓯊M̎AM\ǂAMMf[^[');
    textOut(xxpos, ypos + 12, 'ŁARg[MB');
    Font.color := clRed;
    iil := textwidth('ŁARg[MB') + xxpos;
    textOut(iil, ypos + 12, 'g mɂB');
    Font.color := clblack;
    iil := iid and 2;
    case iil of
      0: LL := 'None';
      2: LL := 'RtsCts';
    end;
    xpos := bitbtn6.left + bitbtn6.width + 10;
    ypos := bitbtn6.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'Lɑ΂Af[^[ł͂ȂAڐڑꂽAMŁA');
    textOut(xxpos, ypos + 12, 'Rg[MB');
    textOut(bitbtn6.left + bitbtn6.width + 10,bitbtn6.top + 2,LL);
    iil := iid and 1;
    case iil of
      0: LL := 'None';
      1: LL := 'DtrDsr';
    end;
    xpos := bitbtn7.left + bitbtn7.width + 10;
    ypos := bitbtn7.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'ʓIɂ́Aob@fԂŁAM\ł邩ǂ');
    textOut(xxpos, ypos + 12, '̐MAMŒڐڑB');

    LL := intTostr(HexNadiaForm.UsbComm1.port);
    xpos := bitbtn8.left + bitbtn8.width + 10;
    ypos := bitbtn8.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'gp|[gԍ@cuł́AP`CQa');

    LL := intTostr(hexNo);
    xpos := bitbtn9.left + bitbtn9.width + 10;
    ypos := bitbtn9.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'Psɕ\AMgR[h');

    if HexNadiaForm.UsbComm1.ReadErrShow = ShowOff then LL := ' '
                                            else LL := ' L';
    xpos := bitbtn10.left + bitbtn10.width + 10;
    ypos := bitbtn10.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'MG[̃`FbN(Read Err Check ݒ͕ۑ܂B)');

    xpos := bitbtn12.left + bitbtn12.width + 10;
    ypos := bitbtn12.top + 2;
    bitbtn12.Caption := 'Break' + #13#10 + 'SendTime';
    LL := intTostr(HexNadiaForm.UsbComm1.BreakSendTime);
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'u[NM  mSec');

    xpos := bitbtn13.left + bitbtn13.width + 10;
    ypos := bitbtn13.top + 2;
    LL := intTostr(HexNadiaForm.UsbComm1.SendTimeOut);
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'M^CAEg  mSec');
    xpos := bitbtn14.left + bitbtn13.width + 10;
    ypos := bitbtn14.top + 2;
    if EventCr then LL := 'Ms'
               else LL := 'ʏs';
    textOut(xpos, ypos, LL);
    textOut(xxpos + 15, ypos, 'f[^[Ms邩Ȃ̎włB');
    inpflg := 0;
    with BitBtn11 do begin Top := 390;
      width := 80;
      Left := HexcomsetForm.ClientWidth div 2 - Width div 2;
      height := 25;
      Visible := true;
    end;
  end;
end;

procedure THexcomsetForm.BitBtn1Click(Sender: TObject);
begin
  inpflg := 1;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
  setupin;
end;

procedure THexcomsetForm.BitBtn2Click(Sender: TObject);
begin
  inpflg := 2;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
  setupin;
end;

procedure THexcomsetForm.BitBtn3Click(Sender: TObject);
begin
  inpflg := 3;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
  setupin;
end;

procedure THexcomsetForm.BitBtn4Click(Sender: TObject);
begin
  inpflg := 4;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
  setupin;
end;

procedure THexcomsetForm.BitBtn5Click(Sender: TObject);
begin
  inpflg := 5;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
  setupin;
end;

procedure THexcomsetForm.BitBtn6Click(Sender: TObject);
begin
  inpflg := 6;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
  setupin;
end;

procedure THexcomsetForm.BitBtn7Click(Sender: TObject);
begin
  inpflg := 7;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
  setupin;
end;


procedure THexcomsetForm.SpinButton1DownClick(Sender: TObject);
begin
  if inpflg = 1 then
    begin
      if iicomset >1 then dec(iicomset);
      Edit1.text := intToStr(Ratein[iicomset]);
    end;
  if inpflg = 8 then
    begin
      if HexNadiaForm.UsbComm1.port > 1 then
        begin
          HexNadiaForm.UsbComm1.port := HexNadiaForm.UsbComm1.port - 1;
          Edit1.text := intToStr(HexNadiaForm.UsbComm1.port);
        end;
    end;
  if inpflg = 9 then
    begin
      if hexNo > 10 then
        begin
          dec(hexNo);
          Edit1.text := intToStr(HexNo);
        end;
    end;
  if inpflg = 10 then
    if  HexNadiaForm.UsbComm1.BreakSendTime > 100 then
      begin
        HexNadiaForm.UsbComm1.BreakSendTime := HexNadiaForm.UsbComm1.BreakSendTime - 10;
        Edit1.text := intToStr(HexNadiaForm.UsbComm1.BreakSendTime);
      end;
  if inpflg = 11 then
    if  HexNadiaForm.UsbComm1.SendTimeOut >= 200 then
      begin
        HexNadiaForm.UsbComm1.SendTimeOut := HexNadiaForm.UsbComm1.SendTimeOut - 100;
        HexNadiaForm.UsbComm1.ReceiveTimeOut := HexNadiaForm.UsbComm1.SendTimeOut;
        Edit1.text := intToStr(HexNadiaForm.UsbComm1.SendTimeOut);
      end
      else
      begin
        HexNadiaForm.UsbComm1.SendTimeOut := 0;
        HexNadiaForm.UsbComm1.ReceiveTimeOut := HexNadiaForm.UsbComm1.SendTimeOut;
        Edit1.text := intToStr(HexNadiaForm.UsbComm1.SendTimeOut);
      end
end;

procedure THexcomsetForm.SpinButton1UpClick(Sender: TObject);
begin
  if inpflg = 1 then
    begin
      if iicomset < 17 then inc(iicomset);
      Edit1.text := intToStr(Ratein[iicomset]);
    end;
  if inpflg = 8 then
    begin
      if HexNadiaForm.UsbComm1.port < 256 then
        begin
          HexNadiaForm.UsbComm1.port := HexNadiaForm.UsbComm1.port + 1;
          Edit1.text := intToStr(HexNadiaForm.UsbComm1.port);
        end;
    end;
  if inpflg = 9 then
    if hexNo < 40 then
      begin
        inc(hexNo);
        Edit1.text := intToStr(HexNo);
      end;
  if inpflg = 10 then
    if  HexNadiaForm.UsbComm1.BreakSendTime < 10000 then
      begin
        HexNadiaForm.UsbComm1.BreakSendTime := HexNadiaForm.UsbComm1.BreakSendTime + 100;
        Edit1.text := intToStr(HexNadiaForm.UsbComm1.BreakSendTime);
      end;
  if inpflg = 11 then
    if  HexNadiaForm.UsbComm1.SendTimeOut < 200000 then
      begin
        HexNadiaForm.UsbComm1.SendTimeOut := HexNadiaForm.UsbComm1.SendTimeOut + 100;
        HexNadiaForm.UsbComm1.ReceiveTimeOut := HexNadiaForm.UsbComm1.SendTimeOut;
        Edit1.text := intToStr(HexNadiaForm.UsbComm1.SendTimeOut);
      end;
end;

procedure THexcomsetForm.BitBtn11Click(Sender: TObject);
var
  test: integer;
begin
  case inpflg of
    0:  begin
          Lset := '';
          for test := 1 to hexNo do Lset := Lset + 'FF,';
          Cx := HexNadiaForm.Canvas.TextWidth(Lset);
          Fpmax := hexNo * 3;
          HexNadiaForm.show;
          HexNadiaForm.ConnectBtn.Enabled := True;
          HexNadiaForm.SetBtn.Enabled := True;
          hide;
          HexNadiaForm.ChangeFormSize;
          HexNadiaForm.VerText;
          HexNadiaForm.Enabled := True;
        end;
    1: HexNadiaForm.UsbComm1.BaudRate := Ratein[iicomset];
  end;
  setcomm1disp;
end;

procedure THexcomsetForm.RadioButton1Click(Sender: TObject);
begin
  with HexNadiaForm.UsbComm1 do begin
    case inpflg of
      2:  ByteSize := cbs8;
      3:  StopBits := csb1;
      4:  ParityBits := cpbNone;
      5:  begin
            infflg := byte(FlowControls);
            infflg := infflg and (7 - 4);
            case infflg of
              0 : FlowControls := [];
              1 : FlowControls := [cfcDtrDsr];
              2 : FlowControls := [cfcRtsCts];
              3 : FlowControls := [cfcRtsCts,cfcDtrDsr];
            end;
          end;
      6:  begin
            infflg := byte(FlowControls);
            infflg := infflg and (7 - 2);
            case infflg of
              0 : FlowControls := [];
              1 : FlowControls := [cfcDtrDsr];
              4 : FlowControls := [cfcXonXoff];
              5 : FlowControls := [cfcXonXoff,cfcDtrDsr];
            end;
          end;
      7:  begin
            infflg := byte(FlowControls);
            infflg := infflg and (7 - 1);
            case infflg of
              0 : FlowControls := [];
              2 : FlowControls := [cfcRtsCts];
              4 : FlowControls := [cfcXonXoff];
              6 : FlowControls := [cfcRtsCts,cfcXonXoff];
            end;
          end;
    end;
  end;
end;

procedure THexcomsetForm.RadioButton2Click(Sender: TObject);
begin
  with HexNadiaForm.UsbComm1 do begin
    case inpflg of
      2:  ByteSize := cbs7;
      3:  StopBits := csb15;
      4:  ParityBits := cpbodd;
      5:  begin
            infflg := byte(FlowControls);
            infflg := infflg or 4;
            case infflg of
              4 : FlowControls := [cfcXonXoff];
              5 : FlowControls := [cfcXonXoff,cfcDtrDsr];
              6 : FlowControls := [cfcRtsCts,cfcXonXoff];
              7 : FlowControls := [cfcRtsCts,cfcXonXoff,cfcDtrDsr];
            end;
          end;
      6:  begin
            infflg := byte(FlowControls);
            infflg := infflg or 2;
            case infflg of
              2 : FlowControls := [cfcRtsCts];
              3 : FlowControls := [cfcRtsCts,cfcDtrDsr];
              6 : FlowControls := [cfcRtsCts,cfcXonXoff];
              7 : FlowControls := [cfcRtsCts,cfcXonXoff,cfcDtrDsr];
            end;
          end;
      7:  begin
            infflg := byte(FlowControls);
            infflg := infflg or 1;
            case infflg of
              1 : FlowControls := [cfcDtrDsr];
              3 : FlowControls := [cfcRtsCts,cfcDtrDsr];
              5 : FlowControls := [cfcXonXoff,cfcDtrDsr];
              7 : FlowControls := [cfcRtsCts,cfcXonXoff,cfcDtrDsr];
            end;
          end;
    end;
  end;
end;

procedure THexcomsetForm.RadioButton3Click(Sender: TObject);
begin
  with HexNadiaForm.UsbComm1 do begin
    case inpflg of
      2: ByteSize := cbs6;
      3: StopBits := csb2;
      4: ParityBits := cpbeven;
    end;
  end;
end;

procedure THexcomsetForm.RadioButton4Click(Sender: TObject);
begin
  with HexNadiaForm.UsbComm1 do begin
    case inpflg of
      2: ByteSize := cbs5;
      4: ParityBits := cpbMark;
    end;
  end;
end;

procedure THexcomsetForm.RadioButton5Click(Sender: TObject);
begin
  with HexNadiaForm.UsbComm1 do begin
    case inpflg of
      2: ByteSize := cbs4;
      4: ParityBits := cpbspace;
    end;
  end;
end;

procedure THexcomsetForm.BitBtn8Click(Sender: TObject);
begin
  inpflg := 8;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr 8,portNoin
  setupin;
end;

procedure THexcomsetForm.BitBtn9Click(Sender: TObject);
begin
  inpflg := 9;// s
  setupin;
end;

procedure THexcomsetForm.BitBtn10Click(Sender: TObject);
begin
  with Image1.canvas do begin
    Font.name := 'lr SVbN';
    Font.style := [];
    Font.height := 12;
    Font.Color := clblack;
    with HexNadiaForm.UsbComm1 do begin
      if ReadErrShow = ShowOff then
        begin
          ReadErrShow := ShowOn;
          LL := ' L';
          HexNadiaForm.UsbComm1.EventMask := [evRxChar,evBreak,evErr];
        end
        else
        begin
          ReadErrShow := ShowOff;
          LL := ' ';
          HexNadiaForm.UsbComm1.EventMask := [evRxChar,evBreak];
        end;
    end;
    xpos := bitbtn10.left + bitbtn10.width + 10;
    ypos := bitbtn10.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xxpos, ypos, 'MG[̃`FbN');
  end;
end;

procedure THexcomsetForm.BitBtn12Click(Sender: TObject);
begin
  inpflg := 10;// 10 u[NMԐݒ
  setupin;
end;

procedure THexcomsetForm.BitBtn13Click(Sender: TObject);
begin
  inpflg := 11;// 11 ^CAEgԐݒ
  setupin;
end;

procedure THexcomsetForm.BitBtn14Click(Sender: TObject);
begin
    if EventCr then EventCr := False
               else EventCr := True;
    xpos := bitbtn14.left + bitbtn14.width + 10;
    ypos := bitbtn14.top + 2;
    if EventCr then LL := 'Ms'
               else LL := 'ʏs';
    Image1.canvas.textOut(xpos, ypos,'@@@@@@');
    Image1.canvas.textOut(xpos, ypos, LL);
end;

end.

