unit Asccomset;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Spin, Registry;
type
    Baud= array [1..17] of Dword;
    TAsccomsetForm = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    SpinButton1: TSpinButton;
    Edit1: TEdit;
    BitBtn12: TBitBtn;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    BitBtn11: TBitBtn;
    Edit2: TEdit;
    Edit3: TEdit;
    BitBtn13: TBitBtn;
    BitBtn14: TBitBtn;
    Edit4: TEdit;
    BitBtn15: TBitBtn;
    Edit5: TEdit;
    BitBtn16: TBitBtn;
    Edit6: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit7: TEdit;
    Edit8: TEdit;
    BitBtn17: TBitBtn;
    Edit9: TEdit;
    Edit10: TEdit;
    BitBtn18: TBitBtn;
    BitBtn19: TBitBtn;
    ComboBox1: TComboBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure BitBtnClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit8KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1Change(Sender: TObject);

  private
    { Private 錾 }
    procedure commsetclear;
    procedure CrCfNoin;             // s
    procedure PortNoin;
    procedure BaudRatein;
    procedure ByteSizein;
    procedure StopBitsin;
    procedure ParityBitsin;
    procedure XonXoffin;
    procedure RtsCtsin;
    procedure DtrDsrin;
    procedure setupin;
    procedure btnalloff;
    procedure delimiterin;          // ̋؂ݒ
    procedure errSet;
    procedure TimeOutin;
    procedure Waittimein;
    procedure OkClick;
    procedure delimiterChenge;
    function TimeOutData: Boolean;
    procedure BreakTimein;
    function BreakTimeD: Boolean;
    procedure EventCharInput;
    function EventcharD: Boolean;
    procedure EventCharsInput;
    procedure ClearFChang;

  public
    { Public 錾 }
    procedure setcomm1disp;
  end;


var
  AsccomsetForm: TAsccomsetForm;

const
  Ratein:Baud =(110,300,600,1200,2400,4800,9600,19200,38400,57600,
                115200,128000,230400,256000,460800,512000,921600);

implementation

uses AscMain,WprcComm;

var
   iicomset : integer;
   inpflg:     byte;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr 8,portNo
                    // 9, s
   inpflgBack: integer;
   infflg:     byte;// ۰p
   xpos,ypos:        integer;
   LL: string;

{$R *.DFM}

procedure TAscComsetForm.commsetclear;
var
  CRect:  TRect;
begin
  ClientHeight := 510;
  CRect := Rect(0,0,Panel1.Clientwidth,Panel1.ClientHeight);
  Image1.canvas.Brush.style := bsSolid;
  Image1.canvas.Brush.color := clwhite;
  Image1.canvas.FillRect(CRect);
end;

procedure TAscComsetForm.btnalloff;
var
  II : integer;
  Cpm: TComponent;
begin
  for II := 1 to 11 do
    begin
      Cpm := FindComponent('BitBtn' + IntTosTr(II));
      TBitBtn(Cpm).Visible := False;
    end;
  for II := 1 to 5 do
    begin
      Cpm := FindComponent('RadioButton' + IntToStr(II));
      TRadioButton(Cpm).Visible := False;
      TRadioButton(Cpm).Checked := False;
    end;
  for II := 1 to 10 do
    begin
      Cpm := FindComponent('Edit' + IntToStr(II));
      TEdit(Cpm).Visible := False;
    end;
  for II := 13 to 19 do
    begin
      Cpm := FindComponent('BitBtn' + IntTosTr(II));
      TBitBtn(Cpm).Visible := False;
    end;
  for II := 1 to 2 do
    begin
      Cpm := FindComponent('CheckBox' + IntTosTr(II));
      TBitBtn(Cpm).Visible := False;
    end;
  Spinbutton1.Visible := False;
  combobox1.Visible := False;
end;

function TAscComsetForm.EventcharD: Boolean;
var
  Editstr: Ansistring;
  Indb: Byte;
  chii: integer;
begin
  Result := False;
  EventF := 0;
  if CheckBox1.Checked then EventF := 1;
  if CheckBox2.Checked then
    begin
      if EventF > 0 then exit;
      EventF := 2;
    end;
  Editstr := AnsiString(Edit6.Text);
  if length(Editstr) = 1 then
    begin
      EventCharInD := Editstr[1];
      Result := True;
    end;
  if Editstr[1] = '#' then
    begin
      Editstr := Copy(Editstr,2,Length(Editstr) -1);
      Val(String(Editstr),indb,chii);
      if chii = 0 then
        begin
          EventCharInD := Ansichar(Indb);
          Result := True;
        end;
    end;
  if Editstr[1] = '$' then
    begin
      Val(String(Editstr),indb,chii);
      if chii = 0 then
        begin
          EventCharInD := Ansichar(Indb);
          Result := True;
        end;
    end;
  if not Result then exit;
  if eventF = 1 then
    begin
      with AscNadiaForm.WPRCComm1 do begin
        if ReaderrShow = ShowOff then EventMask := [evRxchar,evBreak]
                                 else EventMask := [evRxchar,evBreak,evErr];
        EventFlag := Null;
        EventFlagIn := #0;
        RxflagReceive := eventOff;
      end;
    end;
  if eventF = 2 then
    begin
      with AscNadiaForm.WPRCComm1 do begin
        if ReaderrShow = ShowOff then EventMask := [evRxflag,evBreak]
                                 else EventMask := [evRxflag,evBreak,evErr];
        EventFlag := UserIn;
        EventFlagIn := EventCharInD;
        RxflagReceive := eventOn;
      end;
    end;
end;

procedure TAscComsetForm.EventCharsInput;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 400;
  Clientwidth := 580;
  with Edit9 do begin Left := 350;Top := 328;Width := 45;Height := 25;Font.height := 20;Visible := True;
                                                                            Font.Height := 15;
                    Text := intTostr(EventChars);
                end;
  with BitBtn12 do begin Visible := True;Top := 360;Left := 250;Width := 80;Height := 25;end;

  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,22,'MɂAM荞ݔ̎w');
    Font.height := 13;
    Font.color := clBlack;
    TextOut(20,40,'@f[^[Mꍇ̊荞݂̔  w肵܂B');
    TextOut(20,55,'ʏ́A荞ݔ̕ P ŁAȊO͎gp܂B');
    TextOut(20,70,'@Af[^[WCOM|[gŎM̏ꍇAԊu(14x)ŁA荞݂');
    TextOut(20,85,'AŌ̃f[^[MŁA[̊荞݂܂B');
    TextOut(20,100,'[Aw蕶ȉ̏ꍇA荞ݔǂݎ܂B');
    TextOut(20,115,'@tra|[ggpŎM̏ꍇ́AMr͎w蕶ȏ̃_ԊuɊ');
    TextOut(20,130,'݂邩Aw蕶ԊuŁA荞݂܂B');
    TextOut(20,145,'@ʐMxAAṽtHOhł́AsԂꍇ́AǂA');
    TextOut(20,160,'荞ݔ̊ԊuAȂA_ɂȂ܂B');
    TextOut(20,175,'ǂɂĂAŌ̎Mf[^[̒Aw蕶菭ȂƁA');
    TextOut(20,190,'ǂݎ܂B');
    Font.height := 15;
    Font.color := clRed;

    TextOut(20,210,' Œ蒷̃f[^[MȊOAgpĂ͂܂');
    TextOut(20,230,'Œ蒷̃f[^[MłAʏ́A@"P" ƂA');
    TextOut(20,250,'Avŏ܂B');
    TextOut(20,270,'ł́AẃAۑ܂AeXgpƂĎgpĂB');
    TextOut(20,290,'ݒ~XhׂłB');
    Font.color := clblue;
    TextOut(230,330,'w蕶 ');
  end;
end;

procedure TAscComsetForm.EventCharInput;
begin
  commsetclear;
  btnalloff;
  if EventF = 1 then CheckBox1.Checked := True
                else CheckBox1.Checked := False;
  if EventF = 2 then CheckBox2.Checked := True
                else CheckBox2.Checked := False;
  Edit6.Text := String(EventCharInD);
  if EventCharInD = #10 then Edit6.Text := '#10';
  if EventCharInD = #13 then Edit6.Text := '#13';
  if EventCharInD = #0 then Edit6.Text := '#0';
  if EventCharInD = #27 then Edit6.Text := '#27';
  With CheckBox1 do begin
    Left := 200;top := 200;Width := 300;Height := 25;Font.Height := 20;Visible := True;
    Caption := 'ʏ핶M';
  end;
  With CheckBox2 do begin
    Left := 200;top := 230;Width := 300;Height := 25;Font.Height := 20;Visible := True;
    Caption := 'w蕶M';
  end;
  with Edit6 do begin Left := 400;Top := 310;Width := 45;Height := 25;Font.height := 18;Visible := True;end;
  with BitBtn12 do begin Visible := True;Top := 450;Left := 250;Width := 80;Height := 25;end;
  with Edit8 do begin Left := 480;Top := 380;Width := 40;Height := 25;Font.height := 20;Visible := True;
                                                                            Font.Height := 13;Text := ''; end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,2,'MɂAM荞ݔ̎w');
    Font.height := 13;
    Font.color := clBlack;
    TextOut(20,20,'@f[^[Mꍇ̊荞݂̔̕@w肵܂B');
    TextOut(20,35,'ʏ핶ḾAʂ̕@ŁASĂ̎Mɑ΂Ċ荞݂̔܂B');
    TextOut(20,50,'w蕶ḾAw肵MꍇɊ荞݂𔭐܂B');
    TextOut(20,65,'@Af[^[WCOM|[gŎM̏ꍇAԊu(14x)ŁA荞݂');
    TextOut(20,80,'AŌ̃f[^[MŁA([)荞݂܂B');
    TextOut(20,95,'tra|[ggpŎM̏ꍇ́AMr̓_ԊuɊ荞݂AŌ');
    TextOut(20,110,'̃f[^[MŊ荞݂܂B');
    TextOut(20,125,'@ʐMxAAṽtHOhł́AsԂꍇ́AǂA');
    TextOut(20,140,'荞ݔ̊ԊuAȂA_ɂȂ܂B');
    TextOut(20,155,'@w蕶荞ݔ̏ꍇAʐMxɂāAw蕶ɑ΂Đx');
    TextOut(20,170,'荞݂ꍇL܂B');
    Font.height := 12;
    TextOut(50,260,'ꕶw肵܂(s) At@xbgw肵܂B(a b A B 1 1)');
    TextOut(50,275,'A(0Dh)́A#13  s(OAh)́A#10 ESCL[ #27w肵ĂB');
    TextOut(50,290,'HexR[hgp͕A(0Dh)́A$13  s(OAh)́A$0A ESCL[ $1Bw肵ĂB');
    TextOut(150,382,' l킩Ȃꍇ́AẼ{bNXɃJ[\ړ');
    TextOut(150,397,'L[{[h̃L[ĂB');
    TextOut(150,412,'L[R[h\܂B');
    Font.height := 14;
    TextOut(310,314,'w蕶 ');
  end;
end;

function TAscComsetForm.BreakTimeD: Boolean;
var
  Check: integer;
  TBack: DWord;
begin
  Result := True;
  TBack := BreakSendTime;
  Val(EDIT5.Text,BreakSendTime,Check);
  if Check <> 0 then
    begin
      Result := False;
      Exit;
    end;
  if BreakSendTime = 0 then
    begin
      BreakSendTime := TBack;
      Application.MessageBox('lO([)ł͂܂B','',MB_OK);
      EDIT5.Text := IntTostr(BreakSendTime);
      Result := False;
      Exit;
    end;
  AscNadiaForm.WPRCComm1.BreakSendTime := BreakSendTime;
end;

procedure TAscComsetForm.BreakTimein;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  with Edit5 do begin Left := 100;Top := 150;Width := 100;Height := 25;Font.height := 20;Visible := True;end;
  with BitBtn12 do begin Visible := True;Top := 300;Left := 250;Width := 80;Height := 25;end;
  Edit5.Text := IntTostr(BreakSendTime);
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clBlack;
    TextOut(210, 155,'mSec');
    Font.color := clblue;
    TextOut(30,10,'u[NM');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50, 30,'u[NMԂݒ肵܂B');
    TextOut(50, 45,'u[N̑MԂ́A̋@ɍ킹ĂB');
    TextOut(50, 60,'tra@qrQRQbϊɂ́Au[N̑M͂ł邪');
    TextOut(50, 75,'M̏oȂ̂܂B');
    TextOut(50, 90,'mFĂgpĂB');
  end;
end;

function TAscComsetForm.TimeOutData: Boolean;
var
  Check,indat: integer;
  TBack: DWord;
begin
  Result := True;
  TBack := TimeOutD;
  Val(EDIT4.Text,indat,Check);
  if Check <> 0 then
    begin
      Result := False;
      Exit;
    end;
  if indat < 0 then
    begin
      TimeOutD := TBack;
      Application.MessageBox('lO([)ȉł͂܂B','',MB_OK);
      EDIT4.Text := IntTostr(TimeOutD div 1000);
      Result := False;
      Exit;
    end;
  TimeOutD := indat * 1000;
  AscNadiaForm.WPRCComm1.SendTimeOut := TimeOutD;
  AscNadiaForm.WPRCComm1.ReceiveTimeOut := TimeOutD;
end;

procedure TAscComsetForm.TimeOutin;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  with Edit4 do begin Left := 100;Top := 150;Width := 70;Height := 25;Font.height := 20;Visible := True;end;
  with BitBtn12 do begin Visible := True;Top := 300;Left := 250;Width := 80;Height := 25;end;
  Edit4.Text := IntTostr(TimeOutD div 1000);
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'M^CAEgԐݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50, 30,'M̃^CAEg̎Ԃݒ肵܂B');
    TextOut(50, 45,'MJnA͎MJnAăf[^[鎞ԂłB');
    TextOut(50, 60,'^CAEgԂzȂ͈͂Ńf[^[؂đM΁AAőM܂B');
    TextOut(50, 75,'{[[gƁAMAԂݒ肵ĉB');
    TextOut(50, 90,'ḾA^CAEgƊ֌WȂMł܂B');
    TextOut(50,105,'OƁA^CAEg͎gp܂B');

    TextOut(150,185,'Sec ()@͕͂bPʂłB');
  end;
end;

procedure TAscComsetForm.CrCfNoin;//s
begin
  commsetclear;
  btnalloff;
  ClientHeight := 300;
  Spinbutton1.Visible := True;
  with Edit1 do begin Left := 100;Top := 100;Width := 150;Height := 25;Font.height := 20;Visible := True;end;
  with SpinButton1 do begin Top := 100;Left := Edit1.left + Edit1.width; height := Edit1.height;end;
  with BitBtn12 do begin Visible := True;Top := 250;Left := 250;Width := 80;Height := 25;end;
  Edit1.text := intToStr(AscNadiaForm.FPmax);
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'s̓');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50, 30,'M\́AsύX܂B');
    TextOut(50, 45,'SOŏAPQWől');
    TextOut(50, 60,'tHg傫āAw蕶\oȂꍇ');
    TextOut(50, 75,'Iɕ\ȂȂ܂B');
    TextOut(80,140,'傫tHgw肵āAȂȂꍇ');
    TextOut(80,155,'tHgw肵ĂAɖ߂܂AĎw肵ĂB');
  end;
end;

procedure TAscComsetForm.PortNoin;
var
  i: integer;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  with Edit1 do begin left := 100;Visible := True;Top := 120;Width := 150;Height := 20;Font.height := 15;
    Edit1.text := intToStr(AscNadiaForm.WPRCComm1.Port);
  end;
  with Spinbutton1 do begin
    Visible := True;
    Top := 120;
    Left := Edit1.left + Edit1.width;
    Height := Edit1.height;
  end;
  with BitBtn12 do begin Visible := True;Top := 300;Left := 250;Width := 80;Height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'|[gm̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'p\RɂAݒo|[gmقȂ܂B(P`QTU)');
    TextOut(50,45,'ӂĉB');
    TextOut(50,60,'|[gԍ̑IłAݒ\łB');
    TextOut(50,75,'USB-RS232CϊP[ugpꍇ́A|[gԍ̐ݒ̑O');
    TextOut(50,90,'ϊP[uɐڑĂĉB');
  end;
  with combobox1 do begin
    Visible := True; Top := 120; Left := 300; Width := 120; Height := 25;
    Font.height := 15;
  end;
  with TRegistry.Create(KEY_READ) do
    try
      RootKey := HKEY_LOCAL_MACHINE;
      OpenKey('HARDWARE\DEVICEMAP\SERIALCOMM', False);
      GetValueNames(ComboBox1.Items);
      for i:=0 to ComboBox1.items.count-1 do
        begin
          ComboBox1.items[i]:=ReadString(ComboBox1.items[i]);
        end;
    finally
      free;
    end;
end;

procedure TAscComsetForm.BaudRatein;
var
     jj : integer;
     chf: Boolean;
begin
  chf := False;
  for jj := 1 to 17 do
    begin
      if  AscNadiaForm.WPRCComm1.BaudRate = Ratein[jj] then
        begin
          chf := true;
          iicomset := jj;
          break;
        end;
      if AscNadiaForm.WPRCComm1.BaudRate > Ratein[jj] then iicomset := jj;
    end;
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  with Edit1 do begin
    Visible := True;Left := 100;Top := 100;Width := 150;Height := 25;
    Font.height := 20;
    if chf then
        text := intToStr(Ratein[iicomset])
      else
        text := intToStr(AscNadiaForm.WPRCComm1.BaudRate);
    ReadOnly := False;
    SetFocus;
    jj := Length(text);
    SelStart := JJ;
    SelLength := 0;
  end;
  with Spinbutton1 do begin Visible := True; Top := 100;Left := Edit1.left + Edit1.width;
                            height := Edit1.height; end;
  with BitBtn12 do begin Visible := True;Top := 250;Left := 250;Width := 80;Height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'ʐMx̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'p\RɂAݒoʐMxقȂ܂B');
    TextOut(50,45,'ӂĉB');
    TextOut(50,200,'L[{[hŎRȒlɐݒ肷鎖\łB');
  end;
end;

procedure TAscComsetForm.ByteSizein;
var
  iil: byte;
  Cpm: TComponent;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  for iil := 1 to 5 do
    begin
      Cpm := FindComPonent('RadioButton' + IntToStr(iil));
      TRadioButton(Cpm).Width := 100;
      TRadioButton(Cpm).height := 25;
      TRadioButton(Cpm).top := 100 + 30 * (iil - 1);
      TRadioButton(Cpm).left := 150;
      TRadioButton(Cpm).Caption := IntToStr(9 - iil) + '  bit';
      TRadioButton(Cpm).Visible := True;
    end;
  with BitBtn12 do begin Visible := True;Top := 280;Left := 250;Width := 80;Height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'f[^[̃rbg̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'ʏ@yсA𑗂ꍇ́AWrbgʂłB');
    TextOut(50,45,'AXL[R[h ̂ ̏ꍇ́AVrbg̎܂B');
    TextOut(50,60,'WQTȌꍇASrbg͖łB');
  end;
  iil := byte(AscNadiaForm.WPRCComm1.ByteSize);
  case iil of
    4: RadioButton1.Checked := True;
    3: RadioButton2.Checked := True;
    2: RadioButton3.Checked := True;
    1: RadioButton4.Checked := True;
    0: RadioButton5.Checked := True;
  end;
end;

procedure TAscComsetForm.StopBitsin;
var
  iil: byte;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  with RadioButton1 do begin Visible := True;Width := 100;Height := 25;top := 100;Left := 150;
                             Caption := '1   bit';end;
  with RadioButton2 do begin Visible := True;top := 150;Left := 150;Height := 25;Width := 100;
                             Caption := '1.5 bit';end;
  with RadioButton3 do begin Visible := True;Width := 100;Height := 25;Top := 200;Left := 150;
                             Caption := '2   bit';end;
  with BitBtn12 do begin Top := 270;Left := 250;Width := 80;Height := 25;Visible := True;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'Xgbvrbg̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'ʏ́AXgbvrbg̐́APƂ܂B');
    TextOut(50,45,'WQTȌꍇAf[^[TƃXgbvrbgQ̑gݍ킹͖łB');
    TextOut(50,60,'f[^[UCVCWƃXgbvrbgPDT̑gݍ킹łB');
  end;
  iil := byte(AscNadiaForm.WPRCComm1.StopBits);
  case iil of
    0: RadioButton1.Checked := True;
    1: RadioButton2.Checked := True;
    2: RadioButton3.Checked := True;
  end;
end;

var
  Parity: array[1..5] of string = ('None','odd','even','Mark','space');

procedure TAscComsetForm.ParityBitsin;
var
  iil: byte;
  Cpm: TComponent;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  for iil := 1 to 5 do
    begin
      Cpm := FindComponent('RadioButton' + IntToStr(iil));
      TRadioButton(Cpm).width := 100;
      TRadioButton(Cpm).height := 25;
      TRadioButton(Cpm).top := 100 + 30 * (iil - 1);
      TRadioButton(Cpm).left := 150;
      TRadioButton(Cpm).Caption := Parity[iil];
      TRadioButton(Cpm).Visible := True;
    end;
  with BitBtn12 do begin Visible := True;Top := 270;Left := 250;Width := 80;Height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'peBrbg̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'ʐMG[`FbNp̃rbgłB');
    TextOut(50,45,'ʐMƓɂKv܂B');
  end;
  iil := byte(AscMain.AscNadiaForm.WPRCComm1.ParityBits);
  case iil of
    0: RadioButton1.Checked := True;
    1: RadioButton2.Checked := True;
    2: RadioButton3.Checked := True;
    3: RadioButton4.Checked := True;
    4: RadioButton5.Checked := True;
  end;
end;

procedure TAscComsetForm.XonXoffin;
var
   iil: byte;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  with RadioButton1 do begin Visible := True;width := 100;height := 25;top := 100;left := 150;
                             Caption := 'None';end;
  with RadioButton2 do begin Visible := True;width := 100;height := 25;top := 150;left := 150;
                             Caption := 'XonXoff';end;
  with BitBtn12 do begin Visible := True;Top := 270;Left := 250;width := 80;height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'ʐM̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'M\ǂ̐łB');
    TextOut(50,45,'M\ǂAɁAf[^[𑗂邱ƂŐ䂷@B');
  end;
  iil := byte(AscMain.AscNadiaForm.WPRCComm1.FlowControls);
  iil := iil and 4;
  case iil of
    0: RadioButton1.Checked := True;
    4: RadioButton2.Checked := True;
  end;
end;

procedure TAscComsetForm.RtsCtsin;
var
  iil: byte;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  with RadioButton1 do begin Visible := True;width := 100;height := 25;top := 100;left := 150;
                             Caption := 'None';end;
  with RadioButton2 do begin Visible := True;width := 100;height := 25;top := 150;left := 150;
                             Caption := 'RtsCts';end;
  with BitBtn12 do begin Visible := True;Top := 270;Left := 250;width := 80;height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'ʐM̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'M\ǂ̐łB');
    TextOut(50,45,'M\ǂAڐڑꂽMōs@łB');
  end;
  iil := byte(AscMain.AscNadiaForm.WPRCComm1.FlowControls);
  iil := iil and 2;
  case iil of
    0:  RadioButton1.Checked := True;
    2:  RadioButton2.Checked := True;
  end;
end;

procedure TAscComsetForm.DtrDsrin;
var
   iil: byte;
begin
  commsetclear;
  btnalloff;
  ClientHeight := 350;
  with RadioButton1 do begin Visible := True;left := 150;top := 100;width := 100;height := 25;
                             Caption := 'None';end;
  with RadioButton2 do begin Visible := True;width := 100;height := 25;top := 150;left := 150;
                             Caption := 'DtrDsr';end;
  with BitBtn12 do begin Visible := True;Top := 270;Left := 250;width := 80;height := 25;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'ʐM̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'M\ǂ̐łB');
    TextOut(50,45,'ʓIɁAfƂ̊ԂŒڐڑꂽMōs܂B');
  end;
  iil := byte(AscMain.AscNadiaForm.WPRCComm1.FlowControls);
  iil := iil and 1;
  case iil of
    0: AscComsetForm.RadioButton1.Checked := True;
    1: AscComsetForm.RadioButton2.Checked := True;
  end;
end;

procedure TAscComsetForm.delimiterin;//̋؂ݒ
begin
  commsetclear;
  btnalloff;
  with RadioButton1 do begin Visible := True;Width := 200;Height := 25;top := 50;Left := 150;
                             Caption := 'None';end;
  with RadioButton2 do begin Visible := True;Width := 200;Height := 25;top := 100;Left := 150;
                             Caption := 'As $0D0A';end;
  with RadioButton3 do begin Visible := True;Width := 300;Height := 25;top := 150;Left := 150;
                             Caption := 'A $0D Carriage Return';end;
  with RadioButton4 do begin Visible := True;Width := 200;Height := 25;Top := 200;Left := 150;
                             Caption := 's $0A LineFeed';end;
  with RadioButton5 do
    begin Visible := True;Width := 320;Height := 25;Top := 250;Left := 150;
      if ETX1 = #0 then
          Caption := 'STX ETX  $' + IntToHex(Byte(STX),2) + '  $' + IntToHex(Byte(ETX),2)
        else
          Caption := 'STX ETX  $' + IntToHex(Byte(STX),2) + '  $' + IntToHex(Byte(ETX),2)
            + '$' + IntToHex(Byte(ETX1),2);
    end;
  with BitBtn12 do begin Top := 450;Left := 250;Width := 80;Height := 25;Visible := True;end;

  with edit2 do begin Visible := true; width := 50;Height := 20; top := 275;Left := 280;Font.Height := 13;end;
  with edit3 do begin Visible := true; width := 50;Height := 20; top := 275;Left := 370;Font.Height := 13;end;
  with edit7 do begin Visible := true; width := 50;Height := 20; top := 275;Left := 420;Font.Height := 13;end;
  with Edit8 do begin Left := 480;Top := 380;Width := 40;Height := 25;Font.height := 20;Visible := True;
                                                                            Font.Height := 13;Text := ''; end;
  edit2.Text := '$' + IntToHex(Byte(STX),2);
  edit3.Text := '$' + IntToHex(Byte(ETX),2);
  edit7.Text := '$' + IntToHex(Byte(ETX1),2);
  with bitbtn13 do begin Visible := true; width := 40;Height := 20; top := 275;Left := 500;Font.Height := 13;end;
  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(30,10,'̋؂̐ݒ');
    Font.height := 12;
    Font.color := clblack;
    TextOut(50,30,'ʏ́AAs 0D0A');
    TextOut(150,300,'Ō̕ $00 Ƃ΁A͂PƂȂ܂B');
    TextOut(150,315,'$00 ȊO̒lƁAłQM܂B');
    TextOut(150,335,'l̕ύX́AVl͌AύX{^NbNĉB');
    TextOut(150,382,' l킩Ȃꍇ́AẼ{bNXɃJ[\ړ');
    TextOut(150,397,'L[{[h̃L[ĂB');
    TextOut(150,412,'L[R[h\܂B');
    Font.height := 14;
  end;
  case delimiterF of
    0: RadioButton1.Checked := True;
    1: RadioButton2.Checked := True;
    2: RadioButton3.Checked := True;
    3: RadioButton4.Checked := True;
    4: RadioButton5.Checked := True;
  end;
end;

procedure TAscComsetForm.Waittimein;
begin
  commsetclear;
  btnalloff;
  height := 300;

  with Image1.Canvas do begin
    Font.height := 15;
    Font.color := clblue;
    TextOut(50,30,'O̍Ō̏̕IȂM܂ł̑҂Ԃݒ肵܂B');
    TextOut(50,100,'AMw莞̂ݗLłB');
    TextOut(50,115,'҂Ԃ̍ŏĺAO([)AőĺAPOOOłB');
    Font.color := clblack;
    TextOut(455,152,'mSec');
  end;
  with Edit10 do begin Visible := true; width := 80; Height := 20; top := 150; Left := 370; end;
  with BitBtn12 do begin Visible := True;Top := 240;Left := 250;width := 80;height := 25;end;
  Edit10.Text := intTostr(WaitTime);
end;

procedure TAscComsetForm.setupin;
begin
  case inpflg of // 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
    1:  BaudRatein;
    2:  ByteSizein;
    3:  StopBitsin;
    4:  ParityBitsin;
    5:  XonXoffin;
    6:  RtsCtsin;
    7:  DtrDsrin;
    8:  PortNoin;
    9:  CrCfNoin;
   10:  begin
          errSet;
          setcomm1disp;
        end;
   11:  delimiterin;
   12:  OkClick;
   13:  delimiterChenge;
   14:  TimeOutin;
   15:  BreakTimein;
   16:  EventCharInput;
   17:  EventCharsInput;
   18:  Waittimein;
   19:  begin
          ClearFChang;
          setcomm1disp;
        end;
  end;
end;

procedure TAscComsetForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  AscNadiaForm.close;
end;

procedure TAscComsetForm.FormCreate(Sender: TObject);
var
  BRect:  TRect;
  Bitmap: TBitmap;		{rbg}bvێꎞϐ }
  II : integer;
  Cpm: TComponent;
begin
  BorderStyle := bssingle;
  BorderIcons := [biSystemMenu,biMinimize];
  ClientHeight := 540;
  Clientwidth := 580;
  Bitmap := TBitmap.Create;	 {rbg}bvIuWFNg쐬 }
  Bitmap.Width := Clientwidth;		{̕w肷 }
  Bitmap.Height := ClientHeight;		{̍w肷 }
  BRect := Rect(0,0,Clientwidth,ClientHeight);
  with Image1 do begin
    Picture.Graphic := Bitmap;	 {C[WRg[Ƀrbg}bvݒ肷 }
    Top := 0;
    left := 0;
    width := AscComsetForm.Clientwidth;
    Height := AscComsetForm.ClientHeight;		{̍w肷 }
    canvas.Brush.style := bsSolid;
    canvas.Brush.color := clwhite;
    canvas.FillRect(BRect);
  end;
  for II := 1 to 12 do
    begin
      Cpm := FindComponent('BitBtn' + IntToStr(II));
      TBitBtn(Cpm).top :=  20 + 27 * (II - 1);
      TBitBtn(Cpm).Left := 30;
      TBitBtn(Cpm).height := 21;
      TBitBtn(Cpm).Font.Height := 13;
    end;
  for II := 1 to 19 do
    begin
      Cpm := FindComponent('BitBtn' + IntToStr(II));
      TBitBtn(Cpm).OnClick := BitBtnClick;
      TBitBtn(Cpm).Tag := II;
    end;
  for II := 14 to 19 do
    begin
      Cpm := FindComponent('BitBtn' + IntToStr(II));
      TBitBtn(Cpm).Top := 20 + 27 * (II - 3);
      TBitBtn(Cpm).Left := 30;
      TBitBtn(Cpm).Height := 21;
      if II = 14 then TBitBtn(Cpm).Font.Height := 13
                 else TBitBtn(Cpm).Font.Height := 10;
    end;
  inpflg := 0;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr 8,portNo
end;

procedure TAscComsetForm.setcomm1disp;
var
  iil,iid: integer;
  Cpm: TComponent;
begin
  commsetclear;
  btnalloff;
  for IIl := 1 to 11 do
    begin
      Cpm := FindComponent('BitBtn' + IntToStr(IIl));
      TbitBtn(Cpm).Visible := True;
    end;
  for IIl := 14 to 19 do
    begin
      Cpm := FindComponent('BitBtn' + IntToStr(IIl));
      TbitBtn(Cpm).Visible := True;
    end;
  with Image1.Canvas do begin
    Font.Height := 12;
    Font.Name := 'lr SVbN';
    Font.Color := clblack;
    textOut(30, 2, 'M[h̐ݒ');
    LL := intTostr(AscNadiaForm.WPRCComm1.BaudRate);
    xpos := bitbtn1.left + bitbtn1.width + 10;
    ypos := bitbtn1.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xpos + 80, ypos, 'bԂ̃f[^[]xirbgjB');
    iil := byte(AscNadiaForm.WPRCComm1.ByteSize) + 4;
    LL := intTostr(iil);
    xpos := bitbtn2.left + bitbtn2.width + 10;
    ypos := bitbtn2.top + 2;
    textOut(xpos + 80, ypos, '̒l̃rbg@S`WrbgAPoCg͂WrbgB');
    textOut(xpos, ypos, LL);
    iil := byte(AscNadiaForm.WPRCComm1.StopBits);
    case iil of
      0: LL := '1';
      1: LL := '1.5';
      2: LL := '2';
    end;
    xpos := bitbtn3.left + bitbtn3.width + 10;
    ypos := bitbtn3.top + 2;
    textOut(xpos + 80, ypos, '̒l̍Ō̃rbgAf[^[̓ǂݍݎ');
    textOut(xpos + 80, ypos + 12, ']Ԍ덷̕␳ׂ̗̈]Tׂ̈̃rbgB');
    textOut(xpos, ypos, LL);
    //BYTE Parity;           // 0-4=no,odd,even,mark,space
    iil := byte(AscNadiaForm.WPRCComm1.ParityBits);
    case iil of
      0: LL := 'None';
      1: LL := 'odd';
      2: LL := 'even';
      3: LL := 'Mark';
      4: LL := 'space';
    end;
    xpos := bitbtn4.left + bitbtn4.width + 10;
    ypos := bitbtn4.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xpos + 80, ypos, 'peBrbgMG[̌opAw肷B');
    textOut(xpos + 80, ypos + 12, '{́ApeBB');
    iid := byte(AscNadiaForm.WPRCComm1.FlowControls);
    iil := iid and 4;
    case iil of
      0: LL := 'None';
      4: LL := 'XonXoff';
    end;
    xpos := bitbtn5.left + bitbtn5.width + 10;
    ypos := bitbtn5.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xpos + 80, ypos, '񓯊M̎AM\ǂAMMf[^[');
    textOut(xpos + 80, ypos + 12, 'ŁARg[MB');
    iil := iid and 2;
    case iil of
      0: LL := 'None';
      2: LL := 'RtsCts';
    end;
    xpos := bitbtn6.left + bitbtn6.width + 10;
    ypos := bitbtn6.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xpos + 80, ypos, 'Lɑ΂Af[^[ł͂ȂAڐڑꂽAMŁA');
    textOut(xpos + 80, ypos + 12, 'Rg[MB');
    textOut(bitbtn6.left + bitbtn6.width + 10,bitbtn6.top + 2,LL);
    iil := iid and 1;
    case iil of
      0: LL := 'None';
      1: LL := 'DtrDsr';
    end;
    xpos := bitbtn7.left + bitbtn7.width + 10;
    ypos := bitbtn7.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xpos + 80, ypos, 'ʓIɂ́Aob@fԂŁAM\ł邩ǂ');
    textOut(xpos + 80, ypos + 12, '̐MAMŒڐڑB');

    LL := intTostr(AscNadiaForm.WPRCComm1.port);
    xpos := bitbtn8.left + bitbtn8.width + 10;
    ypos := bitbtn8.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xpos + 80, ypos, 'gpbnl|[gԍ    COM1`COMX');

    LL := intTostr(AscNadiaForm.FPmax);
    xpos := BitBtn9.left + BitBtn9.width + 10;
    ypos := AscComsetForm.BitBtn9.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xpos + 80, ypos, 'M\s̐ݒ@SO`PQW');

    xpos := bitbtn10.left + bitbtn7.width + 10;
    ypos := bitbtn10.top + 2;
    if AscNadiaForm.WPRCComm1.ReaderrShow = ShowOff then LL := ' '
                                                   else LL := ' L';
    textOut(xpos, ypos, LL);
    textOut(xpos + 80, ypos, '[h G[`FbN');

    case delimiterF of
      0:  LL := 'None';
      1:  LL := 'As $OD$0A';
      2:  LL := 'A $OD Return';
      3:  LL := 's $OA Line Feed';
      4:  begin
            if ETX1 = #0 then
                LL := 'STX ETX $' + IntToHex(Byte(STX),2) + ' $' + IntToHex(Byte(ETX),2)
              else
                LL := 'STX ETX $' + IntToHex(Byte(STX),2) + ' $' + IntToHex(Byte(ETX),2)
                                                          + '$' + IntToHex(Byte(ETX1),2);
          end;
    end;
    xpos := bitbtn11.left + bitbtn7.width + 10;
    ypos := bitbtn11.top + 2;
    textOut(xpos, ypos, LL);
    textOut(xpos + 140, ypos, 'MtL As A s STXETX');
    textOut(xpos + 140, ypos + 12, '(TerminatoŕAʓI$0D,$0A,$0D$0A)');
    AscNadiaForm.VerText;
    xpos := bitbtn14.left + bitbtn7.width + 10;
    ypos := bitbtn14.top + 2;
    textOut(xpos, ypos,intTostr(TimeOutD) + ' mSec');
    textOut(xpos + 80, ypos, 'M^CAEg');
    xpos := bitbtn15.left + bitbtn7.width + 10;
    ypos := bitbtn15.top + 2;
    textOut(xpos, ypos,intTostr(BreakSendTime) + ' mSec');
    textOut(xpos + 80, ypos, 'u[NM');
    xpos := bitbtn16.left + bitbtn16.width + 10;
    ypos := BitBtn16.Top + 2;
    if eventF = 1 then
      begin
        textOut(xpos + 80, ypos,'ʏ핶Mɂ銄荞 (M荞ݕ@̎w)');
        textOut(xpos, ypos,'S');
      end;
    if eventF = 2 then
      begin
        textOut(xpos + 80, ypos,'w蕶M荞       (M荞ݕ@̎w)');
        LL := String(EventCharInD);
        if EventCharInD = #10 then LL := '#10';
        if EventCharInD = #13 then LL := '#13';
        if EventCharInD = #0 then LL := '#0';
        if EventCharInD = #27 then LL := 'ESC';
        textOut(xpos, ypos,LL);
      end;
    xpos := bitbtn17.left + bitbtn17.width + 10;
    ypos := BitBtn17.Top + 2;
    textOut(xpos, ypos,intTostr(EventChars) + '');
    textOut(xpos + 80, ypos,'M̊荞ݔŒᕶ');
    xpos := bitbtn18.left + bitbtn18.width + 10;
    ypos := BitBtn18.Top + 2;
    textOut(xpos, ypos,intTostr(Waittime) + ' msec');
    textOut(xpos + 80, ypos,'AMAȎMI玟̑M܂ł̑҂');
    xpos := bitbtn19.left + bitbtn19.width + 10;
    ypos := BitBtn19.Top + 2;
    if ClearF then textOut(xpos, ypos,'NAL')
              else textOut(xpos, ypos,'NA');
    textOut(xpos + 80, ypos,'Mf[^[A\\ŉsŃf[^[NAw');
    inpflg := 0;
    inpflgBack := inpflg;
  end;
  with BitBtn12 do begin Visible := true;Top := 480;Left := 250;width := 80;height := 25;end;   //OK{^
end;

procedure TAscComsetForm.BitBtnClick(Sender: TObject);
begin
  inpflg := TBitBtn(Sender).Tag;// 1, ްڰ 2,ޯ 3, įޯ 4,è 5,XONoff 6,rtscts 7,DtrDsr
  if inpflg <> 12 then inpflgBack := inpflg; //    inpflg := 12; OK
  setupin;
end;

procedure TAscComsetForm.SpinButton1DownClick(Sender: TObject);
begin
  if inpflg = 1 then
    begin
      if iicomset >1 then dec(iicomset);
      Edit1.text := intToStr(Ratein[iicomset]);
    end;
  if inpflg = 8 then
    begin
      if AscMain.AscNadiaForm.WPRCComm1.port > 1 then
        begin
          AscNadiaForm.WPRCComm1.port := AscNadiaForm.WPRCComm1.port - 1;
          Edit1.text := intToStr(AscNadiaForm.WPRCComm1.port);
        end;
    end;
  if inpflg = 9 then
    begin
      if AscNadiaForm.FPmax > 40 then
        begin
          Dec(AscMain.AscNadiaForm.FPmax);
          Edit1.text := intToStr(AscNadiaForm.FPmax);
        end;
    end;
end;

procedure TAscComsetForm.SpinButton1UpClick(Sender: TObject);
begin
  if inpflg = 1 then
    begin
      if iicomset < 17 then inc(iicomset);
      Edit1.text := intToStr(Ratein[iicomset]);
    end;
  if inpflg = 8 then
    begin
      if AscMain.AscNadiaForm.WPRCComm1.port < 256 then
        begin
          AscNadiaForm.WPRCComm1.port := AscNadiaForm.WPRCComm1.port + 1;
          Edit1.text := intToStr(AscNadiaForm.WPRCComm1.port);
        end;
    end;
  if inpflg = 9 then
    begin
      if AscMain.AscNadiaForm.FPmax < 128 then
        begin
          inc(AscNadiaForm.FPmax);
          Edit1.text := intToStr(AscNadiaForm.FPmax);
        end;
    end;
end;

procedure TAscComsetForm.OkClick;
var
  chk,Bdr: integer;
  Eventsin: Word;
begin
  case inpflgBack of
    0:  begin
          AscNadiaForm.show;
          hide;
          AscNadiaForm.ChangeFormSize;
          exit;
        end;
    1:  begin
          Val(Edit1.Text,Bdr,chk);
          if chk = 0 then AscNadiaForm.WPRCComm1.BaudRate := BDr
                     else
                     begin
                        Application.MessageBox('͒llł͂܂','Look',MB_OK);
                        exit;
                     end;
          edit1.ReadOnly := true;
        end;
   14:  if not TimeOutData then exit;
   15:  if not BreakTimeD then exit;
   16:  if not EventcharD then exit;
   17:  begin
          Val(Edit9.Text,Eventsin,chk);
          if chk = 0 then
            begin
              if AscNadiaForm.WPRCComm1.ReceiveNotifySize < Eventsin then
                begin
                  Application.MessageBox('͒l傫܂B','Look',MB_OK);
                  exit;
                end
                else
                begin
                  EventChars := Eventsin;
                  AscNadiaForm.WPRCComm1.ReceiveThreshold := EventChars;
                end;
            end
            else
            begin
              Application.MessageBox('͒llł͂܂','Look',MB_OK);
              exit;
            end;
        end;
   18:  begin
          Val(Edit10.Text,WaitTime,chk);
          if chk = 0 then
            begin
              if 10000 < WaitTime then
                begin
                  Application.MessageBox('͒l傫܂B','Look',MB_OK);
                  exit;
                end;
            end
            else
            begin
              Application.MessageBox('͒llł͂܂','Look',MB_OK);
              exit;
            end;
        end;
  end;
  setcomm1disp;
end;

procedure TAscComsetForm.RadioButton1Click(Sender: TObject);
begin
  with AscNadiaForm.WPRCComm1 do begin
    case inpflg of
      2:  ByteSize := cbs8;
      3:  StopBits := csb1;
      4:  ParityBits := cpbNone;
      5:  begin
            infflg := byte(FlowControls);
            infflg := infflg and (7 - 4);
              case infflg of
                0 : FlowControls := [];
                1 : FlowControls := [cfcDtrDsr];
                2 : FlowControls := [cfcRtsCts];
                3 : FlowControls := [cfcRtsCts,cfcDtrDsr];
              end;
          end;
      6:  begin
            infflg := byte(FlowControls);
            infflg := infflg and (7 - 2);
              case infflg of
                0 : FlowControls := [];
                1 : FlowControls := [cfcDtrDsr];
                4 : FlowControls := [cfcXonXoff];
                5 : FlowControls := [cfcXonXoff,cfcDtrDsr];
              end;
          end;
      7:  begin
            infflg := byte(AscMain.AscNadiaForm.WPRCComm1.FlowControls);
            infflg := infflg and (7 - 1);
            case infflg of
              0 : FlowControls := [];
              2 : FlowControls := [cfcRtsCts];
              4 : FlowControls := [cfcXonXoff];
              6 : FlowControls := [cfcRtsCts,cfcXonXoff];
            end;
          end;
      11: delimiterF := 0;
    end;
  end;
end;

procedure TAscComsetForm.RadioButton2Click(Sender: TObject);
begin
  with AscNadiaForm.WPRCComm1 do begin
    case inpflg of
      2: ByteSize := cbs7;
      3: StopBits := csb15;
      4: ParityBits := cpbodd;
      5:  begin
            infflg := byte(FlowControls);
            infflg := infflg or 4;
            case infflg of
              4 : FlowControls := [cfcXonXoff];
              5 : FlowControls := [cfcXonXoff,cfcDtrDsr];
              6 : FlowControls := [cfcRtsCts,cfcXonXoff];
              7 : FlowControls := [cfcRtsCts,cfcXonXoff,cfcDtrDsr];
            end;
          end;
      6:  begin
            infflg := byte(FlowControls);
            infflg := infflg or 2;
            case infflg of
              2 : FlowControls := [cfcRtsCts];
              3 : FlowControls := [cfcRtsCts,cfcDtrDsr];
              6 : FlowControls := [cfcRtsCts,cfcXonXoff];
              7 : FlowControls := [cfcRtsCts,cfcXonXoff,cfcDtrDsr];
            end;
          end;
      7:  begin
            infflg := byte(FlowControls);
            infflg := infflg or 1;
            case infflg of
              1 : FlowControls := [cfcDtrDsr];
              3 : FlowControls := [cfcRtsCts,cfcDtrDsr];
              5 : FlowControls := [cfcXonXoff,cfcDtrDsr];
              7 : FlowControls := [cfcRtsCts,cfcXonXoff,cfcDtrDsr];
            end;
          end;
      11: delimiterF := 1;
    end;
  end;
end;

procedure TAscComsetForm.RadioButton3Click(Sender: TObject);
begin
  with AscNadiaForm.WPRCComm1 do begin
    case inpflg of
      2: ByteSize := cbs6;
      3: StopBits := csb2;
      4: ParityBits := cpbeven;
      11: delimiterF := 2;
    end;
  end;
end;

procedure TAscComsetForm.RadioButton4Click(Sender: TObject);
begin
  with AscNadiaForm.WPRCComm1 do begin
    case inpflg of
      2: ByteSize := cbs5;
      4: ParityBits := cpbMark;
      11: delimiterF := 3;
    end;
  end;
end;

procedure TAscComsetForm.RadioButton5Click(Sender: TObject);
begin
  with AscNadiaForm.WPRCComm1 do begin
    case inpflg of
      2: ByteSize := cbs4;
      4: ParityBits := cpbspace;
      11: delimiterF := 4;
    end;
  end;
end;

procedure TAsccomsetForm.errSet;
begin
  if errShow then errShow := False
             else errShow := True;
  with AscNadiaForm.WPRCComm1 do begin
    if errShow then ReaderrShow := ShowOn
               else ReaderrShow := ShowOff;
    if eventF = 1 then
      begin
        if ReaderrShow = ShowOff then EventMask := [evRxchar,evBreak,evTxempty]
                                 else EventMask := [evRxchar,evBreak,evTxempty,evErr];
      end;
    if eventF = 2 then
      begin
        if ReaderrShow = ShowOff then EventMask := [evRxflag,evBreak,evTxempty]
                                 else EventMask := [evRxflag,evBreak,evTxempty,evErr];
      end;
  end;
end;

procedure TAsccomsetForm.ClearFChang;
begin
  if ClearF then ClearF := False
            else ClearF := true;
end;

procedure TAsccomsetForm.ComboBox1Change(Sender: TObject);
var
  comstr: string;
  leng:  integer;
begin
  comstr := ComboBox1.Text;
  leng := Length(comstr);
  comstr := copy(comstr, 4, leng - 3);
  AscNadiaForm.WPRCComm1.port := strtoint(comstr);
  Edit1.text := intToStr(AscNadiaForm.WPRCComm1.port);
end;

procedure TAsccomsetForm.delimiterChenge;
var
  inD: Byte;
  Check:integer;
begin
  Val(edit2.Text,inD,Check);
  if Check <> 0 then exit;
  STX := Ansichar(ind);
  Val(edit3.Text,inD,Check);
  if Check <> 0 then exit;
  ETX := Ansichar(inD);
  Val(edit7.Text,inD,Check);
  if Check <> 0 then exit;
  ETX1 := Ansichar(inD);
  if ETX1 = #0 then
     RadioButton5.Caption := 'STX ETX  $' + IntToHex(Byte(STX),2) + '  $' + IntToHex(Byte(ETX),2)
    else
     RadioButton5.Caption := 'STX ETX  $' + IntToHex(Byte(STX),2) + '  $' + IntToHex(Byte(ETX),2)
              + '$' + IntToHex(Byte(ETX1),2);
end;

procedure TAsccomsetForm.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then CheckBox2.Checked := False;
end;

procedure TAsccomsetForm.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked then CheckBox1.Checked := False;
end;

procedure TAsccomsetForm.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then
    begin
      Edit2.Text := '$' + intToHex(Byte(Key),2);
      Key := #0;
    end;
end;

procedure TAsccomsetForm.Edit8KeyPress(Sender: TObject; var Key: Char);
var
  Inchb: byte;
begin
  Image1.Canvas.Font.Color := clBlue;
  Image1.Canvas.TextOut(390,400,'L[');
  Image1.Canvas.Font.Color := clRed;
  Image1.Canvas.TextOut(490,400,'     ');
  Inchb := Byte(Key);
  case Inchb of
          27: Image1.Canvas.TextOut(490,400,'ESC');
           8: Image1.Canvas.TextOut(490,400,'BS');
          32: Image1.Canvas.TextOut(490,400,'Space');
          13: Image1.Canvas.TextOut(490,400,'Enter');
    else
      Image1.Canvas.TextOut(490,400,Key);
  end;
  if inpflg = 16 then Edit8.Text := '#' + intTostr(Byte(Key))
                 else Edit8.Text := '$' + intToHex(Byte(Key),2);
  Key := #0;
end;

end.
