unit HexMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Menus, IniFiles, USBComm, system.UITypes;//, ExMemo;

type
  THexNadiaForm = class(TForm)
    Panel1: TPanel;
    ConnectBtn: TSpeedButton;
    StatusBar1: TStatusBar;
    DisconnectBtn: TSpeedButton;
    SetBtn: TBitBtn;
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    FontDialog1: TFontDialog;
    FontBtn: TBitBtn;
    ClearBtn: TBitBtn;
    Memo1: TMemo;
    BreakBtn: TBitBtn;
    Panel2: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    UsbComm1: TUsbComm;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShowHint(Sender: TObject);
    procedure ConnectBtnClick(Sender: TObject);
    procedure DisconnectBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SetBtnClick(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure ChangeFormSize;
    procedure FontBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure BreakBtnClick(Sender: TObject);
    procedure UsbComm1CommEvent(Sender: TObject;
      EventMask: TUsbCommEventMask);
    procedure UsbComm1CommReceive(Sender: TObject; Size: Cardinal);
  private
    FPs: Integer;                           // ǂݏo|C^[
    FPe: Integer;                           // ݃|C^[
    RecvBuf: array [0..127] of ansiChar;        // Mobt@[
    procedure AddToMemo(Flag: Boolean);
    procedure HexSend;
    procedure Iniwrite;
    procedure IniRead;
    procedure SpeedBtnClick(Sender: TObject);
    procedure DataWrite;
  public
    procedure VerText;
    { Public 錾 }
  end;

var
  HexNadiaForm: THexNadiaForm;
  F1: TextFile;{t@C}
  inifname: string;
  inst: array[1..25] of string[5];
  Cx: Integer;
  Lset: string;
  hexNo: integer;     // Ps̕\R[h
  Fpmax:    integer;  // s̕
  LLn:   string;
  fsize:  integer;
  Fstyle1: Tfontstyles;
  Fstyle2: Tfontstyles;
  Fstyle3: Tfontstyles;
  Fstyle4: Tfontstyles;
  fsbyte:  byte;
  dbyte,pbyte,sbyte,fbyte: byte;
  oWord: word;
  BaudSpeed: integer;
  BreakTimeD: Cardinal;
  TimeOutD:   Cardinal;
  EdtStr: string;
  ChStr:  string;
  ComOpenF: Boolean;
  SendChar: ansistring;
  EventCr: Boolean = False;

const
  conma = ',';

implementation

uses Hexcomset;
{$R *.DFM}

{ M }
procedure THexNadiaForm.HexSend;
var
  Strlength: integer;
  II,JJ: integer;
  Ch : Char;
  Sindex,Eindex: integer;
  CheckV: integer;
  inByte: Byte;
begin
  Strlength := length(EdtStr);                                  // ͕̒擾
  if Strlength = 0 then exit;                                   // OI
  if Edtstr[Strlength] <> conma then Edtstr := Edtstr + conma;  // ̍Ōオ','J}ŖJ}ǉ
  Strlength := length(EdtStr);                                  // ͕̒擾
  Sindex := 1;                                                  // CfbNXꕶڂ
  JJ := 0;                                                      // JE^[NA
  SendChar := '';                                               // MNA
  for II := 1 to Strlength do                                   // M쐬[v
    begin
      Ch := EdtStr[II];                                         // Po
      if Ch = conma then                                        // J}mF
        begin                                                   // J}
          Inc(JJ);                                              // JE^[CNg
          Eindex := II - Sindex;                                // vZ
          ChStr := copy(EdtStr, Sindex, Eindex);                // J}؂͕擾
          Val(ChStr, inByte, CheckV);                           // oCgɕϊ
          if CheckV <> 0 then                                   // G[G[\
            begin
              Lset := ' llł͂܂' + #13#10 + intTostr(JJ) + 'Ԗ' + ChStr + #0;
              Application.MessageBox(Pointer(Lset),'Look',MB_OK);
              exit;                                             // G[炻ŏI
            end;
          Sindex := II + 1;                                     // ̐̕擪ԍݒ
          SendChar := SendChar + ansiChar(inByte);              // Mǉ
        end;
    end;
  // G[瑗M
  UsbComm1.Write(PAnsichar(SendChar)^,Length(SendChar));        // P̑M
end;

{ tH[̍쐬 }

procedure THexNadiaForm.FormCreate(Sender: TObject);
var
  CPP: Tcomponent;
  II: integer;
begin
  Fstyle1 := [];
  Fstyle2 := [fsBold];
  Fstyle3 := [fsItalic];
  Fstyle4 := [fsBold,fsItalic];
  BorderStyle := bssingle;
  BorderIcons := [biSystemMenu,biMinimize];
  Application.HintPause := 600;             // wvqg̕\ҋ@
  Application.OnHint := ShowHint;           // qg\pCxgnh

  Fpmax := 128;                             // 40ɃZbg

  FPs := 0;                                 // sobt@̊Jn|C^
  FPe := 0;                                 // sobt@̏݃|C^

  Label1.Caption := 'Mf[^[ ${R[h@@$A5,$04,$0D,$0A ́A255ȓ̐ 18,128,155,13,10';
  Panel1.height := 21;
  StatusBar1.height := 20;
  with Label1 do begin Visible := True;height := 13;Top := 5;width := 50;Left := 305;
                       Font.name := 'lro ';Font.style := [];Font.Height := 12; end;

  with Canvas.Font do begin Name := 'lr SVbN';Pitch := fpFixed;style := [fsBold];Size := 12;end;

  IniRead;
  case fsbyte of
    0: Canvas.Font.Style := Fstyle1;
    1: Canvas.Font.Style := Fstyle2;
    2: Canvas.Font.Style := Fstyle3;
    3: Canvas.Font.Style := Fstyle4;
  end;

  UsbComm1.BaudRate := BaudSpeed;
  case dbyte of
    4 : UsbComm1.ByteSize := cbs8;
    3 : UsbComm1.ByteSize := cbs7;
    2 : UsbComm1.ByteSize := cbs6;
    1 : UsbComm1.ByteSize := cbs5;
    0 : UsbComm1.ByteSize := cbs4;
  end;
  case pbyte of
    0: UsbComm1.ParityBits := cpbNone;
    1: UsbComm1.ParityBits := cpbodd;
    2: UsbComm1.ParityBits := cpbeven;
    3: UsbComm1.ParityBits := cpbMark;
    4: UsbComm1.ParityBits := cpbspace;
  end;
  case sbyte of
    0 : UsbComm1.StopBits :=csb1;
    1 : UsbComm1.StopBits :=csb15;
    2 : UsbComm1.StopBits :=csb2;
  end;
  case fbyte of
    0 : UsbComm1.FlowControls := [];
    1 : UsbComm1.FlowControls := [cfcDtrDsr];
    2 : UsbComm1.FlowControls := [cfcRtsCts];
    3 : UsbComm1.FlowControls := [cfcRtsCts,cfcDtrDsr];
    4 : UsbComm1.FlowControls := [cfcXonXoff];
    5 : UsbComm1.FlowControls := [cfcXonXoff,cfcDtrDsr];
    6 : UsbComm1.FlowControls := [cfcRtsCts,cfcXonXoff];
    7 : UsbComm1.FlowControls := [cfcRtsCts,cfcXonXoff,cfcDtrDsr];
  end;
  if (oWord > 256) or (oWord < 1) then oWord := 1;  // oWord ݒlȊOȂ@P
  UsbComm1.port := oWord;
  UsbComm1.ReadErrShow := ShowOff;
  UsbComm1.EventMask := [evRxChar,evBreak];
  UsbComm1.BreakSendTime := BreakTimeD;
  UsbComm1.SendTimeOut :=TimeOutD;
  UsbComm1.ReceiveTimeOut := TimeOutD;
  UsbComm1.ReceiveMultiplier := 0;
  UsbComm1.SendMultiplier := 0;
  Canvas.Font.name := LLn;
  Canvas.Font.size := fsize;
  with ConnectBtn do
    begin
      Font.Height := 12;
      Font.Pitch := fpFixed;
      Font.style := [fsBold];
      Font.Name := 'lr SVbN';
      Height := 20;
      width := 50;
      left := 0;
    end;
  with DisConnectBtn do
    begin
      Font.Height := 12;
      Font.Pitch := fpFixed;
      Font.style := [fsBold];
      Font.Name := 'lr SVbN';
      Height := 20;
      width := 50;
      left := 50;
      Visible := False;
    end;
  with SetBtn do
    begin
      Font.Height := 12;
      Font.Pitch := fpFixed;
      Font.style := [fsBold];
      Font.Name := 'lr SVbN';
      Height := 20;
      width := 50;
      left := 50;
      Visible := True;
    end;
  with FontBtn do
    begin
      Font.Height := 12;
      Font.Pitch := fpFixed;
      Font.style := [fsBold];
      Font.Name := 'lr SVbN';
      Height := 20;
      width := 50;
      left := 100;
    end;
  with ClearBtn do
    begin
      Font.Height := 12;
      Font.Pitch := fpFixed;
      Font.style := [fsBold];
      Font.Name := 'lr SVbN';
      Height := 20;
      width := 50;
      left := 150;
    end;
  with BreakBtn do
    begin
      Font.Height := 9;
      Font.Pitch := fpFixed;
      Font.style := [];
      Font.Name := 'lr SVbN';
      Height := 20;
      width := 50;
      left := 200;
    end;
  Memo1.left := 0;
  Memo1.top := Panel1.Height;
  Memo1.Font := Canvas.Font;
  Memo1.ClientHeight := Canvas.Textheight('A') * 20 + Canvas.Textheight('A') div 4;
  Clientheight := Memo1.height + StatusBar1.Height + Panel1.Height;
  SpeedButton1.width := 25;
  for II := 1 to 10 do
    begin
      Cpp := FindComponent('SpeedButton' + intTostr(II));
      TSpeedButton(Cpp).Visible := False;
      TSpeedButton(Cpp).Font.Height := 9;
      TSpeedButton(Cpp).Font.Style := [];
      TSpeedButton(Cpp).Font.Name := 'lr SVbN';
      TSpeedButton(Cpp).Hint := 'M' + '|' + 'NbNƁAf[^[𑗐M܂B';
      TSpeedButton(Cpp).ShowHint := True;
      TSpeedButton(Cpp).Caption := 'M';
    end;
  for II := 1 to 10 do
    begin
      Cpp := FindComponent('Edit' + intTostr(II));
      TEdit(Cpp).Visible := False;
      TEdit(Cpp).Font.Name := 'lr SVbN';
      TEdit(Cpp).Font.Style := [];
      TEdit(Cpp).Font.Height := Memo1.Font.Height;
      TEdit(Cpp).Text := '';
    end;
  Lset := '';
  if (hexNo < 10) or (hexNo > 40) then hexNo := 15;
  for II := 1 to hexNo do Lset := Lset + 'FF,';
  Cx := Canvas.TextWidth(Lset);
  FPmax := HexNo * 3;
  ChangeFormSize;
  Memo1.Lines.Clear;
  inifname := ChangeFileExt(Application.ExeName,'.txt');
  if FileExists(inifname) then
    begin
      Assignfile(F1,inifname);
      Reset(F1);
      for II := 1 to 10 do
        begin
          Cpp := FindComponent('Edit' + IntTostr(II));
          ReadLn(F1,Edtstr);
          Tedit(Cpp).Text := Edtstr;
        end;
      CloseFile(F1);
    end;
    VerText;
end;

procedure THexNadiaForm.IniRead;
var
  Ini:TIniFile;
begin
  Ini :=TIniFile.Create(ChangeFileExt(Application.ExeName,'.INI'));
  with Ini do begin
    BaudSpeed := ReadInteger('Comm','BaudRate',2400); // CjVt@CꍇQSOO{[ɐݒ
    dbyte := ReadInteger('Comm','ByteSize',4);        // CjVt@CꍇWrbgɐݒ
    pbyte := ReadInteger('Comm','ParityBits',0);      // CjVt@CꍇpeBɐݒ
    sbyte := ReadInteger('Comm','StopBits',0);        // CjVt@CꍇXgbvrbgPɐݒ
    fbyte := ReadInteger('Comm','FlowControls',0);    // CjVt@CꍇXonXoff  DtrDsroff RtsCtsoff ɐݒ
    oWord := ReadInteger('Comm','port',1);            // CjVt@Cꍇport 1 ɐݒ
    hexNo := ReadInteger('Disp','Number',15);
    LLn := ReadString('Disp','FontName','lr SVbN');
    fsize := ReadInteger('Disp','FontSize',11);
    fsbyte := ReadInteger('Disp','FontStyle',0);
    BreakTimeD := ReadInteger('Comm','BreakTime',500);
    TimeOutD := ReadInteger('Comm','TimeOut',1000);
  end;
  Ini.Free;
end;

procedure THexNadiaForm.Iniwrite;
var
  Ini:TIniFile;
begin
  Ini :=TIniFile.Create(ChangeFileExt(Application.ExeName,'.INI'));
  try
    try
      with Ini do begin
        WriteInteger('Comm','BaudRate',BaudSpeed);
        WriteInteger('Comm','ByteSize',dbyte);
        WriteInteger('Comm','ParityBits',pbyte);
        WriteInteger('Comm','StopBits',sbyte);
        WriteInteger('Comm','FlowControls',fbyte);
        WriteInteger('Comm','port',oWord);
        WriteInteger('Disp','Number',hexNo);        // \R[h
        WriteString('Disp','FontName',LLn);
        WriteInteger('Disp','FontSize',fsize);
        WriteInteger('Disp','FontStyle',fsbyte);
        WriteInteger('Comm','BreakTime',BreakTimeD);
        WriteInteger('Comm','TimeOut',TimeOutD);
      end;
    except
      application.MessageBox('CjVt@C߂܂','',0);
    end;
  finally
    Ini.Free;
  end;
end;

procedure THexNadiaForm.DataWrite;
var
  II: integer;
  cpm: TComponent;
begin
  inifname := ChangeFileExt(Application.ExeName,'.txt');
  Assignfile(F1,inifname);
  try
    Rewrite(F1);
  except
    exit;
  end;
  for II := 1 to 10 do
    begin
      Cpm := FindComponent('Edit' + IntTostr(II));
      Edtstr := Tedit(Cpm).Text;
      Writeln(F1,Edtstr);
    end;
  CloseFile(F1);
end;

{ tH[̃N[Y }
procedure THexNadiaForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ComOpenF then UsbComm1.Close;
  BaudSpeed := UsbComm1.BaudRate;
  dbyte := byte(UsbComm1.ByteSize);
  pbyte := byte(UsbComm1.ParityBits);
  sbyte := byte(UsbComm1.StopBits);
  fbyte := byte(UsbComm1.FlowControls);
  oWord := byte(UsbComm1.port);
  BreakTimeD := UsbComm1.BreakSendTime;
  TimeOutD := UsbComm1.SendTimeOut;
  LLn := Memo1.Font.name;
  fsize := Memo1.Font.size;
  fsbyte := 0;
  if Fstyle1 = Canvas.Font.Style then fsbyte := 0;
  if Fstyle2 = Canvas.Font.Style then fsbyte := 1;
  if Fstyle3 = Canvas.Font.Style then fsbyte := 2;
  if Fstyle4 = Canvas.Font.Style then fsbyte := 3;
  DataWrite;
  Iniwrite;
end;


{ R|[lgɃ}EXJ[\ꍇ }
{ Xe[^Xo[Ƀqg\ }
procedure THexNadiaForm.ShowHint(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := Application.Hint;
end;

procedure THexNadiaForm.VerText;
var
  FLstr: string;
  BufS: string;
begin
  BaudSpeed := UsbComm1.BaudRate;
  dbyte := byte(UsbComm1.ByteSize);
  pbyte := byte(UsbComm1.ParityBits);
  sbyte := byte(UsbComm1.StopBits);
  fbyte := byte(UsbComm1.FlowControls);
  oWord := Word(UsbComm1.port);
  BufS := 'Ver 5.1  Hex coad p@    BaudRate ' + intToStr(BaudSpeed) + ' ByteSize ' + IntTostr(dbyte + 4);
  BufS := BufS + ' Parity ';
  case pbyte of
      0: FLstr := 'None';
      1: FLstr := 'odd';
      2: FLstr := 'even';
      3: FLstr := 'Mark';
      4: FLstr := 'space';
    end;
  BufS := BufS + FLstr;
  case sbyte of
      0: FLstr := '1';
      1: FLstr := '1.5';
      2: FLstr := '2';
  end;

  BufS := BufS + ' StopBits ' + FLstr + ' PortNo ' + IntTostr(oWord) + ' FlowControls ';
  FLstr := 'None';
  if Fbyte and 4 = 4 Then FLstr := 'XonXoff';
  if Fbyte and 2 = 2 then FLstr := FLstr + 'RtsCts';
  if Fbyte and 1 = 1 then FLstr := FLstr + 'DtrDsr';
  BufS := BufS + FLstr;
  Caption := BufS;
end;

{ tHgύXɂʃTCY̕ύX }
procedure THexNadiaForm.ChangeFormSize;
var
  II : integer;
  Cpm: Tcomponent;
begin
  if (Canvas.Font.style =  Fstyle1) or (Canvas.Font.style = Fstyle3) then
         Memo1.ClientWidth := Cx + Canvas.TextWidth('A,') div 2
     else
         Memo1.ClientWidth := Cx + Canvas.TextWidth('A,') div 3;
  ClientWidth :=                                  // tH[̘g
       Memo1.width +                              // 45̕
       GetSystemMetrics(SM_CXVSCROLL) +           // cXN[o[̕
       GetSystemMetrics(SM_CXFRAME) * 2           // t[
       + 400;                                     // Mt[
  Label1.Width := ClientWidth - Label1.Left - 5;
  Panel2.Top := Panel1.height;
  Panel2.Height := Memo1.Height;
  Panel2.Left := Memo1.Width;
  Panel2.Width := ClientWidth - Memo1.Width;
  for II := 1 to 10 do
    begin
      Cpm := FindComponent('Edit' + IntToStr(II));
      TEdit(Cpm).Left := 0;
      TEdit(Cpm).Top := Memo1.height div 10 * (II - 1);
      TEdit(Cpm).Width := Panel2.ClientWidth - SpeedButton1.width;
      TEdit(Cpm).Font.Height := Memo1.Font.Height;
      TEdit(Cpm).Height := Abs(Memo1.Font.Height) + 10;
    end;
  for II := 1 to 10 do
    begin
      Cpm := FindComponent('SpeedButton' + IntToStr(II));
      TSpeedButton(Cpm).Left := Panel2.ClientWidth - SpeedButton1.width;
      TSpeedButton(Cpm).Top := Memo1.height div 10 * (II - 1);
      TSpeedButton(Cpm).Width := 25;
      TSpeedButton(Cpm).Height := Abs(Memo1.Font.Height) + 10;
      TSpeedButton(Cpm).OnClick := SpeedBtnClick;     // OnClickt
      TSpeedButton(Cpm).Tag := II;                    // ^ONo
    end;
end;

// ------------ ʐM֘A֐Q ----------------------------------------------

{ ڑ }
procedure THexNadiaForm.ConnectBtnClick(Sender: TObject);
var
  Cpp : Tcomponent;
  II: integer;
begin
  try
    UsbComm1.Open;                               // VAʐMI[v
  except
    MessageDlg('|[gOPENo܂B', mtInformation,[mbOk], 0);
    DisconnectBtn.Down := True;
    ComOpenF := False;;
    exit;
  end;
  ComOpenF := True;
  Memo1.TabStop := false;
  setBtn.Visible := False;
  BreakBtn.Visible := True;
  DisConnectBtn.Visible := True;
  for II := 1 to 10 do
    begin
      Cpp := FindComponent('Edit' + intTostr(II));
      Tedit(Cpp).Visible := true;
      TEdit(Cpp).Font.Height := Memo1.Font.Height;
    end;
  for II := 1 to 10 do
    begin
      Cpp := FindComponent('SpeedButton' + intTostr(II));
      TSpeedButton(Cpp).Visible := True;
    end;
  Memo1.SetFocus;
  ChangeFormSize;
end;


{ ؒf }
procedure THexNadiaForm.DisconnectBtnClick(Sender: TObject);
var
  Cpp: Tcomponent;
  II :integer;
begin
  UsbComm1.Close;
  ComOpenF := False;
  setBtn.Visible := True;
  BreakBtn.Visible := False;
  DisconnectBtn.Visible := False;
  for II := 1 to 10 do
    begin
      Cpp := Findcomponent('Edit' + IntTostr(II));
      Tedit(Cpp).Visible := False;
    end;
  for II := 1 to 10 do
    begin
      Cpp := Findcomponent('SpeedButton' + IntTostr(II));
      TSpeedButton(Cpp).Visible := False;
    end;
end;

procedure THexNadiaForm.FormResize(Sender: TObject);
begin
     ChangeFormSize;
end;

procedure THexNadiaForm.SetBtnClick(Sender: TObject);
begin
  HexcomsetForm.Show;
  HexNadiaForm.Hide;
  HexNadiaForm.ConnectBtn.Enabled := False;
  HexNadiaForm.SetBtn.Enabled := False;
  HexcomsetForm.setcomm1disp;
  HexcomsetForm.top := HexNadiaForm.top;
  HexcomsetForm.left := HexNadiaForm.left;
end;

procedure THexNadiaForm.Copy1Click(Sender: TObject);
begin
  Memo1.copyToclipboard;
end;

procedure THexNadiaForm.Cut1Click(Sender: TObject);
begin
  Memo1.CutToClipboard;
  ChangeFormSize;
end;

procedure THexNadiaForm.Paste1Click(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
  ChangeFormSize;
end;

procedure THexNadiaForm.FontBtnClick(Sender: TObject);
var
  test: integer;
begin
  FontDialog1.Font := canvas.Font;
  If FontDialog1.Execute then
  begin
    canvas.Font := FontDialog1.Font;
    Memo1.Font := Canvas.Font;
    Memo1.ClientHeight := Canvas.Textheight('A') * 20 + Canvas.Textheight('A') div 4;
    Clientheight := Memo1.height + StatusBar1.Height + Panel1.Height;
  end;
  Lset := '';
  for test := 1 to hexNo do Lset := Lset + 'FF,';
  Cx := Canvas.TextWidth(Lset);
  ChangeFormSize;
end;

procedure THexNadiaForm.ClearBtnClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Fps := 0;
  FPe := 0;
end;

procedure THexNadiaForm.SpeedBtnClick(Sender: TObject);
var
  TagNo: integer;
  Cpm: Tcomponent;
begin
  TagNo := TSpeedButton(Sender).Tag;
  Cpm := FindComponent('Edit' + IntToStr(TagNo));
  Edtstr := TEdit(Cpm).Text;
  HexSend;
end;

procedure THexNadiaForm.BreakBtnClick(Sender: TObject);
begin
  UsbComm1.SendBreak;
end;

{Cxg}
procedure THexNadiaForm.UsbComm1CommEvent(Sender: TObject;
  EventMask: TUsbCommEventMask);
var
  z, x  : integer;
  S     : ansistring;
begin
  if EventMask = [evBreak] then
    begin
      S := 'Break';
      z := length(S);
      for x := 1 to z do
        begin
          RecvBuf[FPe] := s[x];
          Inc(FPe);
          if FPe >= Fpmax then AddToMemo(true);                   // obt@zo͕o
        end;
      RecvBuf[FPe] := ',';
      Inc(FPe);
      if FPe >= Fpmax then AddToMemo(true);                   // obt@zo͕o
      if FPe > FPs then AddToMemo(false);                         // obt@ɗ܂Ăo
    end;
end;

{ M }
procedure THexNadiaForm.UsbComm1CommReceive(Sender: TObject;
  Size: Cardinal);
var
  Buf: PansiChar;
  i,z,x: Integer;
  S: ansistring;
begin
  Buf := AllocMem(Size + 1);                                      // [̊m
  UsbComm1.Read(Buf, Size);                                       // RS232C̓ǂݍ
  StatusBar1.Panels[0].Text := 'M ' + intTostr(Size);
  for i := 0 to Size - 1 do                                       // M
    begin
      S :=  ansistring(intTohex(byte(Buf[i]),2));
      z :=  length(S);
      for x := 1 to z do
        begin
          RecvBuf[FPe] := S[x];
          Inc(FPe);
        end;
      RecvBuf[FPe] := ',';
      Inc(FPe);
      if FPe >= Fpmax then AddToMemo(true);                     // obt@zo͕o
    end;
  if FPe > FPs then                                             // obt@ɗ܂Ăo
    if EventCr then AddToMemo(True)
               else AddToMemo(False);

  FreeMem(Buf,Size+1);                                          // [̉
end;

{ ւ̒ǉ }
procedure THexNadiaForm.AddToMemo(Flag: boolean);
var
  texbuf: string;
begin
  if Flag then
    begin
      RecvBuf[FPe] := #13;
      RecvBuf[FPe+1] := #10;
      Inc(Fpe, 2);
    end;
  Memo1.selStart := Memo1.GetTextLen;                                  // memo1̍ŌɃJ[\Zbg
  RecvBuf[FPe] := #0;                                                  // u@bt@Ō̕Null
  texbuf := string(RecvBuf);                                           // ansiR[h -> uniR[h
  SendMessage(memo1.Handle, EM_REPLACESEL, 0, Integer(Pchar(texbuf))); // SɂPso
  FPs := 0;                                                            // obt@NA
  FPe := 0;                                                            // obt@NA
end;

end.

